{{
@file pjcon.spin
jvm constants
}}

CON
  Jem_NOP               = $00
  Jem_ICONST_M1         = $01
  Jem_ICONST_0          = $02
  Jem_ICONST_1          = $03
  Jem_ICONST_2          = $04
  Jem_ICONST_3          = $05
  Jem_ICONST_4          = $06
  Jem_ICONST_5          = $07
  Jem_BIPUSH            = $08
  Jem_SIPUSH            = $09
  Jem_ILOAD             = $0A
  Jem_ILOAD_0           = $0B
  Jem_ILOAD_1           = $0C
  Jem_ILOAD_2           = $0D
  Jem_ILOAD_3           = $0E
  Jem_ISTORE            = $0F
  Jem_ISTORE_0          = $10
  Jem_ISTORE_1          = $11
  Jem_ISTORE_2          = $12
  Jem_ISTORE_3          = $13
  Jem_IFEQ              = $14
  Jem_IFNE              = $15
  Jem_IFLT              = $16
  Jem_IFLE              = $17
  Jem_IFGT              = $18
  Jem_IFGE              = $19
  Jem_IF_ICMPEQ         = $1A
  Jem_IF_ICMPNE         = $1B
  Jem_IF_ICMPLT         = $1C
  Jem_IF_ICMPGE         = $1D
  Jem_IF_ICMPGT         = $1E
  Jem_IF_ICMPLE         = $1F
  Jem_IF_ACMPEQ         = $20
  Jem_IF_ACMPNE         = $21
  Jem_IRETURN           = $22
  Jem_RETURN            = $23
  Jem_INVOKEVIRTUAL     = $24
  Jem_INVOKESTATIC      = $25
  Jem_GETSTATIC         = $26
  Jem_PUTSTATIC         = $27
  Jem_POP               = $28
  Jem_POP2              = $29
  Jem_DUP               = $2A
  Jem_DUP_X1            = $2B
  Jem_DUP_X2            = $2C
  Jem_DUP2              = $2D
  Jem_DUP2_X1           = $2E
  Jem_DUP2_X2           = $2F
  Jem_SWAP              = $30
  Jem_IADD              = $31
  Jem_ISUB              = $32
  Jem_INEG              = $33
  Jem_x34               = $34
  Jem_IOR               = $35
  Jem_x36               = $36
  Jem_ISHL              = $37
  Jem_x38               = $38
  Jem_ISHR              = $39
  Jem_x3A               = $3A
  Jem_IUSHR             = $3B
  Jem_x3C               = $3C
  Jem_IAND              = $3D
  Jem_x3E               = $3E
  Jem_IXOR              = $3F
  Jem_x40               = $40
  Jem_I2B               = $41
  Jem_x42               = $42
  Jem_GOTO              = $43
  Jem_x44               = $44
  Jem_INVOKEINTERFACE   = $45
  Jem_x45               = $46
  Jem_ARRAYLENGTH       = $47
  Jem_x48               = $48
  Jem_ATHROW            = $49
  Jem_x4A               = $4A
  Jem_CHECKCAST         = $4B
  Jem_x4C               = $4C
  Jem_INSTANCEOF        = $4D
  Jem_x4E               = $4E
  Jem_WIDE              = $4F
  Jem_x50               = $50
  Jem_IINC              = $51
  Jem_x52               = $52
  Jem_GETFIELD          = $53
  Jem_x54               = $54
  Jem_PUTFIELD          = $55
  Jem_x56               = $56
  Jem_NEW               = $57
  Jem_x58               = $58
  Jem_NEWARRAY          = $59
  Jem_x5A               = $5A
  Jem_ANEWARRAY         = $5B
  Jem_x5C               = $5C
  Jem_IALOAD            = $5D
  Jem_x5E               = $5E
  Jem_IASTORE           = $5F
  Jem_x60               = $60
  Jem_BALOAD            = $61
  Jem_x62               = $62
  Jem_BASTORE           = $63
  Jem_x64               = $64
  Jem_LDC               = $65
  Jem_x66               = $66
  Jem_LDC_W             = $67
  Jem_x68               = $68
  Jem_LDC2_W            = $69
  Jem_x6A               = $6A
  Jem_IMUL              = $6B
  Jem_x6C               = $6C
  Jem_IDIV              = $6D
  Jem_x6E               = $6E
  Jem_IREM              = $6F
  Jem_x70               = $70
  Jem_JSR               = $71
  Jem_x72               = $72
  Jem_RET               = $73
  Jem_x74               = $74
  Jem_TABLESWITCH       = $75
  Jem_x76               = $76
  Jem_LOOKUPSWITCH      = $77


con
  'javaProg header fields
  JVM_RUNDEBUG     = $0000
  JVM_LENGTH       = $0001
  JVM_VERSION      = $0002
  JVM_STATIC       = $0003
  JVM_MAIN         = $0004
  JVM_OBJECT       = $0006
  JVM_STRING       = $0008
  JVM_THROW        = $000A
  JVM_STRTABLE     = $000C
  JVM_CALLBACK     = $000E
  JVM_MEMERROR     = $0010
  JVM_STKBASE      = $0012

  'class header fields
  JVM_SUPER        = $00
  JVM_FIELDS       = $02
  
  'method header fields
  JVM_PARAMETERS    = $00
  JVM_LOCALS        = $01
  JVM_FLAGS         = $02
  JVM_CODE          = $03
  JVM_EXCEPTION     = $05

  JVM_NATIVE        = $80
  JVM_ENG_NOOFPARMS = 17
  
con
  _PUTC  = "c"
  _PRINT = "s"

PUB OpcodeNamePtr( opcode )
#ifdef OPCODES
'{
  if opcode < Jem_INSTANCEOF
  
    case opcode
      Jem_NOP:             result := String("NOP")
      Jem_ICONST_M1:       result := String("ICONST_M1")
      Jem_ICONST_0:        result := String("ICONST_0")
      Jem_ICONST_1:        result := String("ICONST_1")
      Jem_ICONST_2:        result := String("ICONST_2")
      Jem_ICONST_3:        result := String("ICONST_3")
      Jem_ICONST_4:        result := String("ICONST_4")
      Jem_ICONST_5:        result := String("ICONST_5")
      Jem_BIPUSH:          result := String("BIPUSH")
      Jem_SIPUSH:          result := String("SIPUSH")
      Jem_ILOAD:           result := String("ILOAD")
      Jem_ILOAD_0:         result := String("ILOAD_0")
      Jem_ILOAD_1:         result := String("ILOAD_1")
      Jem_ILOAD_2:         result := String("ILOAD_2")
      Jem_ILOAD_3:         result := String("ILOAD_3")
      Jem_ISTORE:          result := String("ISTORE")
      Jem_ISTORE_0:        result := String("ISTORE_0")
      Jem_ISTORE_1:        result := String("ISTORE_1")
      Jem_ISTORE_2:        result := String("ISTORE_2")
      Jem_ISTORE_3:        result := String("ISTORE_3")
      Jem_IFEQ:            result := String("IFEQ")
      Jem_IFNE:            result := String("IFNE")
      Jem_IFLT:            result := String("IFLT")
      Jem_IFLE:            result := String("IFLE")
      Jem_IFGT:            result := String("IFGT")
      Jem_IFGE:            result := String("IFGE")
      Jem_IF_ICMPEQ:       result := String("IF_ICMPEQ")
      Jem_IF_ICMPNE:       result := String("IF_ICMPNE")
      Jem_IF_ICMPLT:       result := String("IF_ICMPLT")
      Jem_IF_ICMPGE:       result := String("IF_ICMPGE")
      Jem_IF_ICMPGT:       result := String("IF_ICMPGT")
      Jem_IF_ICMPLE:       result := String("IF_ICMPLE")
      Jem_IF_ACMPEQ:       result := String("IF_ACMPEQ")
      Jem_IF_ACMPNE:       result := String("IF_ACMPNE")
      Jem_IRETURN:         result := String("IRETURN")
      Jem_RETURN:          result := String("RETURN")
      Jem_INVOKEVIRTUAL:   result := String("INVOKEVIRTUAL")
      Jem_INVOKESTATIC:    result := String("INVOKESTATIC")
      Jem_GETSTATIC:       result := String("GETSTATIC")
      Jem_PUTSTATIC:       result := String("PUTSTATIC")
      Jem_POP:             result := String("POP")
      Jem_POP2:            result := String("POP2")
      Jem_DUP:             result := String("DUP")
      Jem_DUP_X1:          result := String("DUP_X1")
      Jem_DUP_X2:          result := String("DUP_X2")
      Jem_DUP2:            result := String("DUP2")
      Jem_DUP2_X1:         result := String("DUP2_X1")
      Jem_DUP2_X2:         result := String("DUP2_X2")
      Jem_SWAP:            result := String("SWAP")
      Jem_IADD:            result := String("IADD")
      Jem_ISUB:            result := String("ISUB")
      Jem_INEG:            result := String("INEG")
      Jem_IOR:             result := String("IOR")
      Jem_ISHL:            result := String("ISHL")
      Jem_ISHR:            result := String("ISHR")
      Jem_IUSHR:           result := String("IUSHR")
      Jem_IAND:            result := String("IAND")
      Jem_IXOR:            result := String("IXOR")
      Jem_I2B:             result := String("I2B")
      Jem_GOTO:            result := String("GOTO")
      Jem_INVOKEINTERFACE: result := String("INVOKEINTERFACE")
      Jem_ARRAYLENGTH:     result := String("ARRAYLENGTH")
      Jem_ATHROW:          result := String("ATHROW")
      Jem_CHECKCAST:       result := String("CHECKCAST")

  else
    case opcode
    
      Jem_INSTANCEOF:      result := String("INSTANCEOF")
      Jem_WIDE:            result := String("WIDE")
      Jem_IINC:            result := String("IINC")
      Jem_GETFIELD:        result := String("GETFIELD")
      Jem_PUTFIELD:        result := String("PUTFIELD")
      Jem_NEW:             result := String("NEW")
      Jem_NEWARRAY:        result := String("NEWARRAY")
      Jem_ANEWARRAY:       result := String("ANEWARRAY")
      Jem_IALOAD:          result := String("IALOAD")
      Jem_IASTORE:         result := String("IASTORE")
      Jem_BALOAD:          result := String("BALOAD")
      Jem_BASTORE:         result := String("BASTORE")
      Jem_LDC:             result := String("LDC")
      Jem_LDC_W:           result := String("LDC_W")
      Jem_LDC2_W:          result := String("LDC2_W")
      Jem_IMUL:            result := String("IMUL")
      Jem_IDIV:            result := String("IDIV")
      Jem_IREM:            result := String("IREM")
      Jem_JSR:             result := String("JSR")
      Jem_RET:             result := String("RET")
      Jem_TABLESWITCH:     result := String("TABLESWITCH")
      Jem_LOOKUPSWITCH:    result := String("LOOKUPSWITCH")
      other:               result := String("Unknown")
'}
#endif

pub dummy
