{
con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

obj
  sx : "FullDuplexSingleton"
  
pub main | tptr, proglen
  sx.start(31,30,0,115200)
  waitcnt(clkfreq+cnt)

  tptr := pjd.getTablePtr(0)
  long[tptr] := @jemTable

  proglen := @program_end-@program
  pjd.init(@program, proglen, 1,false)

  start(pjd.getCmdPtr)
  cognew(run, @stack)
  bu.start
  
var  long stack[$20]

pub run
  repeat
    byte[pjd.getCmdPtr] := byte[@program+pjd.getPC]
    byte[pjd.getControlPtr]:= -1
    repeat while long[pjd.getControlPtr]
    
'}

{
con
  JAVACODESIZE = 9500

obj bu : "BmaUtility"

pub start(cmdptr)

  init(cmdptr)
  bu.debug(@vmentry, cmdptr)
'  bu.taskstart(@vmentry, cmdptr, 0)
  waitcnt(clkfreq/4+cnt)

pub debug
  bu.start

'}

'{
con
  JAVACODESIZE = 19000

pub start(cmdptr)

  init(cmdptr)
  cognew(@vmentry, cmdptr)
  waitcnt(clkfreq/4+cnt)

pub debug
  return
'}

pri init(cmdptr) | n, tptr

  long[cmdptr] := 0
  tptr := pjd.getTablePtr(0)
  long[tptr] := @jemTable

' we have to fix up the jem lookup table since spin does not add object offsets for dat.
' add difference between doJem_NOP address and jemTable's address for doJem_NOP to entries.
'
  tptr := @doJem_NOP-jemTable
  repeat n from @jemTable to @jemTableEnd step 2
    word[n] += tptr ' add ptr diff to table


pub getJavaCodeSize
  return JAVACODESIZE
'  return @progbuf_end-@progbuf
  
pub getProgBuffer
  return @progbuf

pub getProgPtr
  return @progbuf

pub getProgSize
  return @progbuf_end-@progbuf

dat
{{
This VM is designed to run in two COGs plus the main Spin COG/handler:

    - one COG is the VM interpreter,
    - the main Spin startup COG is the VM servicer,
    - the main Spin program acts as a handler for slow VM requests.

The role of the VM interpreter is to process byte-codes and will:

    - read bytecodes from the PC location
    - send unhandled exception messages to the Spin VM handler
    - send asynchronous native method messages to the Spin VM handler
    - send asynchronous memory allocation requests to the Spin VM handler (not implemented)

The role of the VM service handlerr is:

    - wait for and service requests from the VM interpreter.
    - The role of the Spin VM handler is: to call functions as necessary to perform
      time insensitive memory allocation, exception handling, and native calls.
}}


'' JVM Interpreter
''
vmentry org 0 
long 0 [8] ' debugger stub is 8 nop with no debugger running
        jmp     #initvm

'_____________________________________________________________________________
' Overlay load loop
'
load    rdlong  inst,   rc wz       ' overlayed code's NOP must be non-zero else load is terminated early
if_nz   add     load,   x800        '   Unroll loop 4x for better performance.
if_nz   add     rc,     #4          '   Fair compromise for short/long instruction interpretation.
load2
if_nz   rdlong  inst2,  rc wz
if_nz   add     load2,  x800
if_nz   add     rc,     #4
load3
if_nz   rdlong  inst3,  rc wz
if_nz   add     load3,  x800
if_nz   add     rc,     #4
load4
if_nz   rdlong  inst4,  rc wz
if_nz   add     load4,  x800
if_nz   add     rc,     #4
if_nz   jmp     #load 
load_ret ret

'_____________________________________________________________________________
' Main interpreter loop
'
jvmDone
        rdlong  index,  cmdp wz      ' if cmdp data != 0
if_nz   tjnz    index,  #$-1         ' wait for handler to finish

jvmloop
        rdlong  index,  pc
        add     index,  jem
' get bytecode
'
        rdbyte  rc,     index wz
        shl     rc,     #1          ' get bytecode word aligned table entry
        add     rc,     table       ' add table address to instruction pointer
        rdword  rc,     rc          ' get method offset
if_z    jmp     #incrPCdone         ' adjust PC and restart just incase bytecode is NOP 0

' handle JVM bytecode calls
'
        movd    load,   #inst       ' set destination to instruction block
        movd    load2,  #inst2      ' set destination to instruction block
        movd    load3,  #inst3      ' set destination to instruction block
        movd    load4,  #inst4      ' set destination to instruction block
        call    #load

inst    long    0
inst2   long    0
inst3   long    0
inst4   long    0 [64-12]              ' no more than 64 instructions per stub ...

'_____________________________________________________________________________
'
initvm  ' over-written with jvm code when necessary ... about 11 instructions
' get and save par pointers
        mov     tp,     par
        mov     t1,     #cmdp
        mov     t0,     #19         ' noof parameters
ploop   movd    pwrite, t1          ' save parameter destination
        add     t1,     #1
pwrite  mov     0-0,    tp          ' save parameter values
        add     tp,     #4
        djnz    t0,     #ploop
        rdlong  jem,    jemp        ' get jem offset
        rdlong  table,  tap         ' get table base address
        jmp     #jvmDone

' each routine must end some way with a jmp jvmDone

x800    long    $800
index   long    0
length  long    0
table   long    0

'_____________________________________________________________________________
'
' kernel services
'_____________________________________________________________________________
'
NewStackFrame
'{
'    sp += jd.readJavaByte(method + jd#JVM_LOCALS)         'skip locals
  mov          rc,  t2      ' t2 = method
  add          rc,  #pcn#JVM_LOCALS   
  call         #loadByte    ' local count
  add          t4,  rc      ' add to sp  t4 = sp
'    jd.writeJavaIntBE(sp,jd.getJvmMP)                     'save old mp
  mov          arg1,t4      ' arg1 = sp + pcnt
  rdlong       rc,  mp                           
  call         #saveWord    ' save old MP in sp
'    jd.writeJavaIntBE(sp+2,jd.getJvmFP)                   'save old fp
  add          arg1,#2      ' arg1 = sp + pcnt + 2
  rdlong       rc,  fp
  call         #saveWord    ' save old FP in sp+2
'    jd.writeJavaIntBE(sp+4,jd.getJvmPC+3)                 'save old pc (= return address)
  add          arg1,#2      ' arg1 = sp + pcnt + 4
  rdlong       rc,  pc
  add          rc,  #3
  call         #saveWord    ' save old PC+3 in sp+4 ... return address
'    jd.setJvmSP(sp+6)                                     'set new sp     
  add          arg1,#2      ' arg1 = sp + pcnt + 6
  wrlong       arg1,sp      ' save sp+6
'    jd.setJvmFP(fp)                                       'set new fp
  wrlong       t3,  fp      ' save fp
'    jd.setJvmMP(method)                                   'set new mp
  mov          rc,  t2      ' t2 = method 
  wrlong       rc,  mp      ' save mp
'    jd.setJvmPC(jd.readJavaIntBE(method + jd#JVM_CODE))   'set new pc
  add          rc, #pcn#JVM_CODE
  call         #loadWord    ' get method + code
  wrlong       rc,  pc      ' set new pc  
'    return -1
  jmp          #jvmDone
'}

'_____________________________________________________________________________
'
doJemIRETURN
'{
  call         #pop
  mov          t4,  rc          ' t4 is safe
  call         #doJemRETURN
  mov          rc,  t4          

  rdword       tp,  sp          ' special push
  add          tp,  jem
  call         #swap16  
  wrword       rc,  tp
  add          tp,  #2
  sub          tp,  jem
  wrword       tp,  sp

  jmp          #jvmDone         
'}

'_____________________________________________________________________________
'
doJemRETURN  
{
  JEM format: return
  method := jd.getJvmMP                          'current method
  size := (jd.readJavaByte(method + jd#JVM_PARAMETERS) & $7F) + jd.readJavaByte(method + jd#JVM_LOCALS) 'offset to saved mp,fp,pc in current frame
  sp := jd.getJvmFP + size
  jd.setJvmMP(jd.readJavaIntBE(sp))              'restore mp     
  fp := jd.readJavaIntBE(sp+2)
  jd.setJvmFP(fp)                                'restore fp
  jd.setJvmPC(jd.readJavaIntBE(sp+4))            'restore pc
  sp -= size
  jd.setJvmSP(sp)                                'restore sp
}
  'size = loadByte(mp+pcn#JVM_PARAMETERS)
  rdlong       rc,  mp
  add          rc,  #pcn#JVM_PARAMETERS
  call         #loadByte
  'size&= #$7f
  and          rc,  #$7f
  'size+= loadByte(mp + pcn#JVM_LOCALS)
  mov          t0,  rc  ' t0 = size
  rdlong       rc,  mp
  add          rc,  #pcn#JVM_LOCALS
  call         #loadByte
  add          t0,  rc
  'sp = fp + size
  rdlong       rc,  fp
  add          rc,  t0  ' t0 = size + parms + locals = method
  mov          t1,  rc  ' t1 = sp
  call         #loadWord
  wrlong       rc,  mp  ' restore mp
  'fp = loadWord(sp+2)
  mov          rc,  t1
  add          rc,  #2
  call         #loadWord
  wrlong       rc,  fp  ' restore fp
  'pc = loadWord(sp+4)
  mov          rc,  t1
  add          rc,  #4
  call         #loadWord
  wrlong       rc,  pc  ' restore pc
  'sp -= size
  sub          t1,  t0
  wrlong       t1,  sp  ' restore sp
doJemRETURN_ret ret    

doJemGETFIELD
'{
  if_ae sub    rc,  jem ' get aref no jem offset
  mov          t0,  rc  ' t0 = aref
'  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  call         #loadWordPcPlus1
  add          rc,  t0  ' offset + aref
'  value := jd.readJavaIntBE(aref + offset)
  call         #loadWord
  'if_ae call   #swap16
  jmp          #pushIncrPC3done
'}

'_____________________________________________________________________________
'
push2121_incrPCdone
  call         #push2
push121_incrPCdone
  call         #push1
push21_incrPCdone
  call         #push2
  call         #push1
  jmp          #incrPCdone

'_____________________________________________________________________________
'
push214321_incrPCdone
  call         #push2
  call         #push1
push4321_incrPCdone
  call         #push4
push321_incrPCdone
  call         #push3
  call         #push2
  call         #push1
  jmp          #incrPCdone

'_____________________________________________________________________________
'
mvRcIncrPCdone
  mov          rc,  arg2
  jmp          #pushIncrPCdone

'_____________________________________________________________________________
'
' push
' long  rc
'
push
  rdword       tp,  sp
  add          tp,  jem
  call         #swap16  
  wrword       rc,  tp
  add          tp,  #2
  sub          tp,  jem
  wrword       tp,  sp
  call         #swap16  
push_ret       ret

'_____________________________________________________________________________
'
' pop
' long  rc
'
pop
  rdword       tp,  sp
  add          tp,  jem
  sub          tp,  #2
  rdword       rc,  tp
  call         #swap16  
  sub          tp,  jem
  wrword       tp,  sp
pop_ret       ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' push1
' input arg1
'
push1
  rdword       tp,  sp
  add          tp,  jem
  wrword       arg1,tp
  add          tp,  #2
  sub          tp,  jem
  wrword       tp,  sp
push1_ret     ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' push2
' input arg2
'
push2
  rdword       tp,  sp
  add          tp,  jem
  wrword       arg2,tp
  add          tp,  #2
  sub          tp,  jem
  wrword       tp,  sp
push2_ret     ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' push3
' input arg3
'
push3
  rdword       tp,  sp
  add          tp,  jem
  wrword       arg3,tp
  add          tp,  #2
  sub          tp,  jem
  wrword       tp,  sp
push3_ret     ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' push4
' input arg4
'
push4
  rdword       tp,  sp
  add          tp,  jem
  wrword       arg4,tp
  add          tp,  #2
  sub          tp,  jem
  wrword       tp,  sp
push4_ret     ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' pop1
' output arg1
'
pop1
  rdword       tp,  sp
  add          tp,  jem
  sub          tp,  #2
  rdword       arg1,tp
  sub          tp,  jem
  wrword       tp,  sp
pop1_ret      ret


'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' pop2
' output arg2
'
pop2
  rdword       tp,  sp
  add          tp,  jem
  sub          tp,  #2
  rdword       arg2,tp
  sub          tp,  jem
  wrword       tp,  sp
pop2_ret      ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' pop3
' output arg3
'
pop3
  rdword       tp,  sp
  add          tp,  jem
  sub          tp,  #2
  rdword       arg3,tp
  sub          tp,  jem
  wrword       tp,  sp
pop3_ret      ret

'_____________________________________________________________________________
' special push/pop for dup etc... no endian translation
' pop4
' output arg4
'
pop4
  rdword       tp,  sp
  add          tp,  jem
  sub          tp,  #2
  rdword       arg4,tp
  sub          tp,  jem
  wrword       tp,  sp
pop4_ret      ret

'_____________________________________________________________________________
'
' swap16
' long  rc
swap          long 0 ' temporary for swap
swap16
  and          rc,Minus1    ' prevent overflow  
  mov          swap,rc
  and          rc,  #$ff
  shr          swap,#8
  shl          rc,  #8
  or           rc, swap
swap16_ret     ret

'_____________________________________________________________________________
'
' setWord16
' long  rc
setWord16                
  and          arg1, Minus1    ' prevent overflow  
  shl          arg1, #8
  or           arg1, arg2
  mov          rc,   arg1
setWord16_ret  ret

'_____________________________________________________________________________
'
' loadBytePcPlus1
' long  rc
'
loadBytePcPlus1
  rdlong       rc,  pc
  add          rc,  jem
  add          rc,  #1   ' add pc+1
  rdbyte       rc,  rc   ' read byte at pc+1
loadBytePcPlus1_ret      ret

'_____________________________________________________________________________
'
' loadWordPcPlus1
' long  rc
'
loadWordPcPlus1
  rdlong       rc,  pc
  add          rc,  jem
  add          rc,  #1   ' add pc+1
  rdbyte       arg1,rc   ' read byte
  add          rc,  #1
  rdbyte       arg2,rc   ' read byte
  call         #setWord16
loadWordPcPlus1_ret      ret

'_____________________________________________________________________________
'
' loadByte
' long  rc
'
loadByte
  add          rc,  jem
  rdbyte       rc,  rc   ' read byte at pc+1
loadByte_ret   ret

'_____________________________________________________________________________
'
' loadWord
' long  rc
'
loadWord
  add          rc,  jem
  rdbyte       arg1,rc   ' read byte
  add          rc,  #1
  rdbyte       arg2,rc   ' read byte
  call         #setWord16' ends with word in rc
loadWord_ret   ret

'_____________________________________________________________________________
'
' saveByte
' long  arg1 = address
' long  rc = data
'
saveByte
  mov          tp,  arg1 ' get bytecode base
  add          tp,  jem
  wrbyte       rc,  tp ' write byte
saveByte_ret   ret

'_____________________________________________________________________________
'
' saveWord
' long  arg1 = address
' long  rc = data
'
saveWord
  mov          tp,  arg1 ' get bytecode base
  add          tp,  jem
  add          tp,  #1
  wrbyte       rc,  tp   ' write word
  shr          rc,  #8
  sub          tp,  #1
  wrbyte       rc,  tp   ' write word
saveWord_ret   ret

'_____________________________________________________________________________
'
' signExtend16
' long  rc
signExtend16
  test         rc,  MSB16 wz
  if_nz or     rc,  M1WDXT
signExtend16_ret   ret

'_____________________________________________________________________________
' loadCmpzWord
' long arg1 = word to compare
' long  rc  = offset for jmp 
loadCmpzWord
  call         #pop
  call         #signExtend16
  mov          arg1,rc          ' w1
  mov          t1, arg1
  rdlong       rc,  pc
  add          rc,  #1
  call         #loadWord        ' rc = offset
  mov          arg1, t1
  cmps         arg1,#0  wz,wc
loadCmpzWord_ret    ret

'_____________________________________________________________________________
' loadCmpWords
' returns
' long arg1 = word 1 to compare
' long arg2 = word 2 to compare
' long  rc  = offset for jmp 
loadCmpWords
  call         #pop
  call         #signExtend16
  mov          arg2,rc          ' w2
  call         #pop
  call         #signExtend16
  mov          arg1,rc          ' w1
  'call         #pop2signed
  mov          t1, arg1         ' w1
  mov          t2, arg2         ' w2
  rdlong       rc,  pc          ' get pc
  add          rc,  #1          ' load word at pc+1
  call         #loadWord        ' rc = offset
  mov          arg1, t1
  mov          arg2, t2
  cmps         arg1,arg2 wz,wc
loadCmpWords_ret    ret

'_____________________________________________________________________________
'
' pop
' long  rc
'
poparg12
  rdword       tp,  sp
  add          tp,  jem
  sub          tp,  #2
  rdword       rc,  tp
  call         #swap16  
  mov          arg1,rc
  sub          tp,  #2
  rdword       rc,tp
  call         #swap16  
  mov          arg2,rc
  sub          tp,  jem
  wrword       tp,  sp
poparg12_ret ret


'_____________________________________________________________________________
'
' pop2signed
' long  arg1
' long  arg2
pop2signed
  call         #pop
  call         #signExtend16
  mov          arg1,rc          ' w1
  call         #pop
  call         #signExtend16
  mov          arg2,rc          ' w2
pop2signed_ret ret


'_____________________________________________________________________________
'
pushIncrPCdone        
  call         #push
incrPCdone
  rdlong       rc,  pc
  add          rc,  #1
  wrlong       rc,  pc
  jmp          #jvmDone

'_____________________________________________________________________________
'
pushIncrPC2done        
  call         #push
incrPC2done
  rdlong       rc,  pc
  add          rc,  #2
  wrlong       rc,  pc
  jmp          #jvmDone

'_____________________________________________________________________________
'
pushIncrPC3done        
  call         #push
incrPC3done
  rdlong       rc,  pc
  add          rc,  #3
  wrlong       rc,  pc
  jmp          #jvmDone

'_____________________________________________________________________________
'
addWordPCdone
  call         #signExtend16
  mov          arg1,rc
addPCdone
  rdlong       rc,  pc
  add          rc,  arg1
  wrlong       rc,  pc
  jmp          #jvmDone

'_____________________________________________________________________________
'
addRcPCDone
  call         #signExtend16
  rdlong       tp, pc
  add          tp, rc
  wrlong       tp, pc
  jmp          #jvmDone

'_____________________________________________________________________________
' arg1 = offset
' rc   = value
setStatic
  rdlong       tp, sbp
  add          tp, arg1
  wrword       rc, tp           ' word wide for 16 bit JVM
setStatic_ret      ret

'_____________________________________________________________________________
' arg1 = offset
getStatic
  rdlong       tp, sbp
  add          tp, arg1
  rdword       rc, tp           ' word wide for 16 bit JVM
getStatic_ret  ret

'_____________________________________________________________________________
'
' alloc
' @parm arg1  number of bytes
' @return rc  new pointer
'
'{ save for unmanaged heap allocation
allocate
  rdlong       rc,  hp
  rdlong       pp,  sp
  cmp          rc,  pp wc   ' hp/sp overlap?
  if_c  mov    rc,  #0      ' yes, return null pointer
  'if_nc rdlong rc,  hp
  if_nc sub    rc,  arg1
  if_nc wrlong rc,  hp      ' get pointer
allocate_ret   ret
'}
{
allocate
'{
  rdlong      rc,  hp
  rdlong      pp,  sp
  cmp         rc,  pp wc
  if_c  mov   rc,  #0
  if_c  jmp   #allocate_ret
'}
  mov         rc, MALLOC    ' handler does alloc if MALLOC_BIT set
  or          rc, arg1      ' request j3arg1 bytes
  wrlong      rc, ctrp      ' write alloc request
  rdlong      rc, ctrp      ' wait for request complete
  cmps        rc, #0  wc      ' wait until D < S
  if_nc       jmp   #$-2        ' if D > S wait for request complete
  rdlong      rc, ap        ' get reference
allocate_ret ret
'}

'_____________________________________________________________________________
'
' multiply
' @parm arg1        term 1
' @parm arg2        term 2
' @return rc        product
'
multiply
  call        #psign
  mov         rc,#0
muloop
  shr         arg1,#1   wc
  if_c  add   rc,arg2
  shl         arg2,#1
  tjnz        arg1,#muloop
multiply_ret  ret

'____________________________________________
' chip's divide
' quotient in arg1
' remainder in arg2
'
divide
  call        #psign
  mov         t1,     #0
  mov         t2,     #32
:div
  shr         arg1,   #1      wz,wc
  rcr         t1,     #1
  if_nz djnz  t2,     #:div
:div2
  cmpsub      arg2,   t1    wc
  rcl         arg1,   #1
  shr         t1,     #1
  djnz        t2,     #:div2
divide_ret   ret               

psign
  test        arg1,   MSB16 wc
  test        arg2,   MSB16 wz
  wrlong      zero,   cp                    'carry is used for storing result sign
  if_c_and_z   wrlong   one,   cp           'result should be negative
  if_nc_and_nz wrlong   one,   cp           'result should be negative
  abs         arg1,   arg1
  abs         arg2,   arg2
psign_ret   ret

signResult
  rdlong      rc,     cp wz
  if_nz       neg     arg1, arg1
  and         arg1,   MINUS1
  mov         rc,     arg1
'  wrlong      zero,   cp                   ' jvm doesn't care about carry for div,mod,mult
signResult_ret ret

'_____________________________________________________________________________
'return readJavaIntBE(stringIndex + (index<<1))
' rc = index
loadConst
  rdlong       tp,  strp    ' stringIndex
  mov          arg3,rc
  shl          arg3,#1
  add          tp,  arg3    ' + index << 1
  mov          rc,  tp
  call         #loadWord      ' rc = return word
loadConst_ret   ret

'_____________________________________________________________________________
'
' set exception
'
exception
  rdlong       rc, pc
  or           rc, MSB16       ' EXCPTN
  or           rc, t0
  wrlong       rc, cmdp        ' set exception command
  jmp          #jvmDone

'_____________________________________________________________________________
'
' iload n
'
iload_n
  rdlong       rc,  fp
  add          rc,  parm
  call         #loadWord
  jmp          #pushIncrPCdone

'_____________________________________________________________________________
'
' istore n
'
istore_n
  call         #pop
  rdlong       arg1,fp
  add          arg1,parm
  call         #saveWord
  jmp          #incrPCdone

'_____________________________________________________________________________
'
' support constants
'
MINUS1  long   $FFFF    ' 16 bit machine
MSB16   long   $8000
MSB8    long   $80
M1WDXT  long   $FFFF0000
M1WDXTM long   $FFFF8000
M1BXT   long   $FF00
x4000   long   $1000
NEG132  long   -1
EXCPTN  long   EXCPTN_BIT
MALLOC  long   MALLOC_BIT


'_____________________________________________________________________________
'
' call variables
'
arg1    long 0
arg2    long 0
arg3    long 0
arg4    long 0
arg5    long 0
rc      long 0

'_____________________________________________________________________________
'
' local variables
'
pp      long 0
tp      long 0
t0      long 0
t1      long 0
t2      long 0
t3      long 0
t4      long 0
t5      long 0
parm    long 0
one     long 1
zero    long 0

'_____________________________________________________________________________
'
' JVM command interface
'
cmdp    long 0      ' shared jvm instruction pointer
ctrp    long 0      ' control pointer 0 if nothing to do
jemp    long 0      ' jem pointer

'_____________________________________________________________________________
'
' JVM  parameter pointers
'
pc      long 0      ' program counter pointer
bp      long 0      ' stack base pointer
sp      long 0      ' stack pointer
fp      long 0      ' frame pointer
mp      long 0      ' method pointer
ap      long 0      ' allocated heap pointer
hp      long 0      ' heap end pointer
ep      long 0      ' exception pointer
cp      long 0      ' carry pointer
sbp     long 0      ' static base pointer
strp    long 0      ' strings pointer
tap     long 0      ' jump table pointer
tap1    long 0      ' jump table pointer unused
tap2    long 0      ' jump table pointer unused
jem     long 0      ' jem base

jvmend  fit         $1f0

con

  NATIVE_BIT = $100
  EXCPTN_BIT = $8000
  MALLOC_BIT = $10000

obj
  pjd: "pjdata"
  pcn: "pjcon"

con
  
' One vision of how this would be done is to have clumps of code
' to execute in the COG and use a jump table for the clumps.
' Another alternative is to have methods defined in HUB ram
' and load the methods via overlay to COG space to run.
'
' The overlay method seems the fastest way to port existing code for now ....
' 
' jvm loop reads each address and jumps there
'
dat
jemTable        ' an instruction that needs overlay will have upper word set
        word @doJem_NOP
        word @doJem_ICONST_M1
        word @doJem_ICONST_0          
        word @doJem_ICONST_1          
        word @doJem_ICONST_2          
        word @doJem_ICONST_3          
        word @doJem_ICONST_4          
        word @doJem_ICONST_5          
        word @doJem_BIPUSH            
        word @doJem_SIPUSH            
        word @doJem_ILOAD             
        word @doJem_ILOAD_0           
        word @doJem_ILOAD_1           
        word @doJem_ILOAD_2           
        word @doJem_ILOAD_3           
        word @doJem_ISTORE            
        word @doJem_ISTORE_0          
        word @doJem_ISTORE_1          
        word @doJem_ISTORE_2          
        word @doJem_ISTORE_3          
        word @doJem_IFEQ              
        word @doJem_IFNE              
        word @doJem_IFLT              
        word @doJem_IFLE              
        word @doJem_IFGT              
        word @doJem_IFGE              
        word @doJem_IF_ICMPEQ         
        word @doJem_IF_ICMPNE         
        word @doJem_IF_ICMPLT         
        word @doJem_IF_ICMPGE         
        word @doJem_IF_ICMPGT         
        word @doJem_IF_ICMPLE         
        word @doJem_IF_ACMPEQ         
        word @doJem_IF_ACMPNE         
        word @doJem_IRETURN           
        word @doJem_RETURN            
        word @doJem_INVOKEVIRTUAL     
        word @doJem_INVOKESTATIC
        word @doJem_GETSTATIC         
        word @doJem_PUTSTATIC         
        word @doJem_POP               
        word @doJem_POP2              
        word @doJem_DUP               
        word @doJem_DUP_X1            
        word @doJem_DUP_X2            
        word @doJem_DUP2              
        word @doJem_DUP2_X1           
        word @doJem_DUP2_X2           
        word @doJem_SWAP              
        word @doJem_IADD              
        word @doJem_ISUB              
        word @doJem_INEG              
        word @doJem_NOP                
        word @doJem_IOR               
        word @doJem_NOP                
        word @doJem_ISHL              
        word @doJem_NOP                
        word @doJem_ISHR              
        word @doJem_NOP                
        word @doJem_IUSHR             
        word @doJem_NOP                
        word @doJem_IAND              
        word @doJem_NOP                
        word @doJem_IXOR              
        word @doJem_NOP                
        word @doJem_I2B               
        word @doJem_NOP                
        word @doJem_GOTO              
        word @doJem_NOP                
        word @doJem_INVOKEINTERFACE   
        word @doJem_NOP                
        word @doJem_ARRAYLENGTH       
        word @doJem_NOP                
        word @doJem_ATHROW            
        word @doJem_NOP                
        word @doJem_CHECKCAST         
        word @doJem_NOP                
        word @doJem_INSTANCEOF        
        word @doJem_NOP                
        word @doJem_WIDE              
        word @doJem_NOP                
        word @doJem_IINC              
        word @doJem_NOP                
        word @doJem_GETFIELD          
        word @doJem_NOP                
        word @doJem_PUTFIELD          
        word @doJem_NOP                
        word @doJem_NEW               
        word @doJem_NOP                
        word @doJem_NEWARRAY          
        word @doJem_NOP                
        word @doJem_ANEWARRAY         
        word @doJem_NOP                
        word @doJem_IALOAD            
        word @doJem_NOP                
        word @doJem_IASTORE           
        word @doJem_NOP                
        word @doJem_BALOAD            
        word @doJem_NOP                
        word @doJem_BASTORE           
        word @doJem_NOP                
        word @doJem_LDC               
        word @doJem_NOP                
        word @doJem_LDC_W             
        word @doJem_NOP                
        word @doJem_NOP                
        word @doJem_NOP                
        word @doJem_IMUL              
        word @doJem_NOP                
        word @doJem_IDIV              
        word @doJem_NOP                
        word @doJem_IREM              
        word @doJem_NOP                
        word @doJem_JSR               
        word @doJem_NOP                
        word @doJem_RET               
        word @doJem_NOP                
        word @doJem_TABLESWITCH       
        word @doJem_NOP                
        word @doJem_LOOKUPSWITCH      
        word @doJem_ENDOFTABLE      
jemTableEnd  long 0

{
' RT debug can be used in Off-COG code to put a value back to cmdp and halt execution
  wrlong  rc, cmdp
  call    #branch
  long    $1ff & (-1)
'}


' JVM bytecode implementation

'_____________________________________________________________________________
dat     org inst
''  doJem_NOP Meaning: Do nothing except Increment PC.
doJem_NOP
  jmp          #incrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ICONST_M1
''  doJem_ICONST_M1 Meaning: Push the integer constant -1.
  mov          rc, MINUS1
  jmp          #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ICONST_0
''  doJem_ICONST_0 Meaning: Push the integer constant 0.
  mov          rc, #0
  jmp          #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ICONST_1
''  doJem_ICONST_1 Meaning: Push the integer constant 1.
  mov          rc, #1
  jmp          #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ICONST_2
''  doJem_ICONST_2 Meaning: Push the integer constant 2.
  mov          rc, #2
  jmp          #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ICONST_3
''  doJem_ICONST_3 Meaning: Push the integer constant 3.
  mov          rc, #3
  jmp          #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ICONST_4
''  doJem_ICONST_4 Meaning: Push the integer constant 4.
  mov          rc, #4
  jmp          #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ICONST_5
''  doJem_ICONST_5 Meaning: Push the integer constant 5.
  mov          rc, #5
  jmp          #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_BIPUSH
''  doJem_BIPUSH Meaning: Push a 1-byte signed integer.
{
  JEM format: bipush,byte1
  byte1 is a signed 1byte constant: if byte1 < 128 const = byte1 else const = byte1 | $FF00 
  val := jd.readJavaByte(jd.getJvmPC+1)
  val := jc.b2i(val)
  js.push(val)
  jd.incJvmPC(2)
}
'  val := jd.readJavaByte(jd.getJvmPC+1)
  call         #loadBytePcPlus1 ' could do move rc, pc; add rc, #1; call #loadByte
'  val := jc.b2i(val)
  test         rc, #$80 wz
  if_nz or     rc, M1BXT  ' byte extend
'  js.push(val)
'  jd.incJvmPC(2)
  jmp          #pushIncrPC2done

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_SIPUSH
''  doJem_SIPUSH Meaning: Push a 2-byte signed integer.
{
  JEM format: sipush,byte1,byte2
  byte1 and byte2 form 16bits constant: const = (byte1<<8)|(byte2) 
  val := jd.readJavaIntBE(jd.getJvmPC+1)
  js.push(val)
  jd.incJvmPC(3)
}
  call         #loadWordPcPlus1 ' could do move rc, pc; add rc, #1; call #loadWord
  jmp          #pushIncrPC3done

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ILOAD
''  doJem_ILOAD Meaning: Load integer from local variable.
{
  JEM format: iload,byte1
  byte1 is the index of the local variable.
  index := jd.readJavaByte(jd.getJvmPC+1)
  fp := jd.getJvmFP
  val := jd.readJavaIntBE(fp + (index<<1))
  js.push(val)
  jd.incJvmPC(2)
}
  call         #loadBytePcPlus1
  mov          t0, rc   ' save index
  shl          t0, #1
  rdlong       rc, fp
  add          rc, t0
  call         #loadWord
  jmp          #pushIncrPC2done

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ILOAD_0
''  doJem_ILOAD_0 Meaning: Load integer from local variable with index 0.
{
  JEM format: iload_0
  fp := jd.getJvmFP
  val := jd.readJavaIntBE(fp)
  js.push(val)
  jd.incJvmPC(1)
}
  mov         parm,#0
  jmp         #iload_n

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ILOAD_1
''  doJem_ILOAD_1 Meaning: Load integer from local variable with index 1.
{
  JEM format: iload_1
  fp := jd.getJvmFP
  val := jd.readJavaIntBE(fp + 2)
  js.push(val)
  jd.incJvmPC(1)
}
  mov         parm,#2
  jmp         #iload_n

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ILOAD_2
''  doJem_ILOAD_2 Meaning: Load integer from local variable with index 2.
{
  JEM format: iload_2
  fp := jd.getJvmFP
  val := jd.readJavaIntBE(fp + 4)
  js.push(val)
  jd.incJvmPC(1)
}
  mov         parm,#4
  jmp         #iload_n

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ILOAD_3
''  doJem_ILOAD_3 Meaning: Load integer from local variable with index 3.

{
  JEM format: iload_3
  fp := jd.getJvmFP
  val := jd.readJavaIntBE(fp + 6)
  js.push(val)
  jd.incJvmPC(1)
}
  mov         parm,#6
  jmp         #iload_n

{ kernel service
iload_n
  rdlong       rc,  fp
  add          rc,  parm
  call         #loadWord
  jmp          #pushIncrPCdone
}

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ISTORE
''  doJem_ISTORE Meaning: Store integer into local variable.
{
  JEM format: istore,byte1
  byte1 is the index of the local variable.
  index := jd.readJavaByte(jd.getJvmPC+1)
  fp := jd.getJvmFP
  val := js.pop
  jd.writeJavaIntBE(fp + (index<<1),val)
  jd.incJvmPC(2)
}
  call         #loadBytePcPlus1
  mov          t0,  rc      ' save index
  shl          t0,  #1
  rdlong       rc,  fp
  add          rc,  t0
  mov          arg1,rc      ' saveWord address
  call         #pop
  call         #saveWord
  jmp          #incrPC2done

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ISTORE_0
''  doJem_ISTORE_0 Meaning: Store integer into local variable with index 0.
{
  JEM format: istore_0
  val := js.pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp,val)
  jd.incJvmPC(1)
}
  mov         parm, #0
  jmp         #istore_n

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ISTORE_1
''  doJem_ISTORE_1 Meaning: Store integer into local variable with index 1.
{
  JEM format: istore_1
  val := js.pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp + 2,val)
  jd.incJvmPC(1)
}
  mov         parm, #2
  jmp         #istore_n

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ISTORE_2
''  doJem_ISTORE_2 Meaning: Store integer into local variable with index 2.
{
  JEM format: istore_2
  val := js.pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp + 4,val)
  jd.incJvmPC(1)
}
  mov         parm, #4
  jmp         #istore_n

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ISTORE_3
''  doJem_ISTORE_3 Meaning: Store integer into local variable with index 3.
{
  JEM format: istore_3
  val := js.pop
  fp := jd.getJvmFP
  jd.writeJavaIntBE(fp + 6,val)
  jd.incJvmPC(1)
}
  mov         parm, #6
  jmp         #istore_n

{ kernel service
istore_n
  call         #pop
  rdlong       arg1,fp
  add          arg1,parm
  call         #saveWord
  jmp          #incrPCdone
}

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IFEQ
''  doJem_IFEQ Meaning: Branch if equal to 0.
{
  JEM format: ifeq,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 == 0
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpzWord
  if_z         jmp #addWordPCdone 'doit       ' if w1 == 0, do jump
  jmp          #incrPC3done
'doit  jmp     #addWordPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IFNE
''  doJem_IFNE Meaning: Branch if not equal to 0.
{
  JEM format: ifne,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 <> 0
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpzWord
  if_nz        jmp #addWordPCdone 'doit       ' if w1 <> 0, do jump
  jmp          #incrPC3done
'doit  jmp     #addWordPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IFLT
''  doJem_IFLT Meaning: Branch if less than 0.
{
  JEM format: iflt,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 < 0
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpzWord
  if_b         jmp #addWordPCdone 'doit       ' if w1 < 0, do jump
  jmp          #incrPC3done
'doit  jmp     #addWordPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IFLE
''  doJem_IFLE Meaning: Branch if less than or equal to 0.
{
  JEM format: ifle,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 =< 0
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpzWord
  if_be        jmp #addWordPCdone 'doit       ' if w1 <= 0, do jump
  jmp          #incrPC3done
'doit  jmp     #addWordPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IFGT
''  doJem_IFGT Meaning: Branch if greater than 0.
{
  JEM format: ifgt,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 > 0
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpzWord
  if_a         jmp #addWordPCdone ''doit       ' if w1 > 0, do jump
  jmp          #incrPC3done
'doit  jmp     #addWordPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IFGE
''  doJem_IFGE Meaning: Branch if greater than or equal to 0.
{
  JEM format: ifge,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 => 0
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpzWord
  if_ae        jmp #addWordPCdone ''doit       ' if w1 >= 0, do jump
  jmp          #incrPC3done
'doit  jmp     #addWordPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IF_ICMPEQ
''  doJem_IF_ICMPEQ Meaning: Branch if integers v1 and v2 are equal.
{
  JEM format: icmpeq,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 == w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpWords
  if_z         jmp #addWordPCdone ''doit       ' if w1 == w2, do jump
  jmp          #incrPC3done
'doit  jmp     #addWordPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IF_ICMPNE
''  doJem_IF_ICMPNE Meaning: Branch if integers v1 and v2 are not equal.
{
  JEM format: icmpne,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 <> w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}    
  call         #loadCmpWords
  if_nz        jmp #addWordPCdone ''doit       ' if w1 <> w2, do jump
  jmp          #incrPC3done
'doit  jmp     #addWordPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IF_ICMPLT
''  doJem_IF_ICMPLT Meaning: Branch if integer v1 is less than integer v2.
{
  JEM format: icmplt,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 < w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpWords
  if_b         jmp #addWordPCdone ''doit       ' if w1 < w2, do jump
  jmp          #incrPC3done
'doit  jmp     #addWordPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IF_ICMPGE
''  doJem_IF_ICMPGE Meaning: Branch if integer v1 is greater than or equal to integer v2.
{
  JEM format: icmpge,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 => w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpWords
  if_ae        jmp #addWordPCdone ''doit       ' if w1 >= w2, do jump
  jmp          #incrPC3done
'doit  jmp     #addWordPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IF_ICMPGT
''  doJem_IF_ICMPGT Meaning: Branch if integer v1 is greater than integer v2.
{
  JEM format: icmpgt,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 > w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpWords
  if_a         jmp #addWordPCdone 'doit       ' if w1 > w2, do jump
  jmp          #incrPC3done
'doit  jmp     #addWordPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IF_ICMPLE
''  doJem_IF_ICMPLE Meaning: Branch if integer v1 is less than or equal to integer v2.
{
  JEM format: icmple,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 =< w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
  call         #loadCmpWords
  if_be        jmp #addWordPCdone 'doit       ' if w1 <= w2, do jump
  jmp          #incrPC3done
'doit  jmp     #addWordPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IF_ACMPEQ
''  doJem_IF_ACMPEQ Meaning: Branch if object references are equal.
{
  JEM format: acmpeq,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 == w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
'  jmp          #doJem_IF_ICMPEQ ' functionally equivalent
  call         #loadCmpWords
  if_z         jmp #addWordPCdone ''doit       ' if w1 == w2, do jump
  jmp          #incrPC3done

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IF_ACMPNE
''  doJem_IF_ACMPNE Meaning: Branch if object references are not equal.
{
  JEM format: acmpne,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 
  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  if w1 <> w2
    jd.incJvmPC(offset)
  else
    jd.incJvmPC(3)
}
'  jmp          #doJem_IF_ICMPNE ' functionally equivalent
  call         #loadCmpWords
  if_nz        jmp #addWordPCdone ''doit       ' if w1 <> w2, do jump
  jmp          #incrPC3done

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IRETURN
''  doJem_IRETURN Meaning: Return integer from function.
{
  JEM format: ireturn
  val := js.pop                               'pop return value
  jb_return                                      'discard frame
  js.push(val)                                'push return value
}
  jmp          #doJemIRETURN
{
  call         #pop
  mov          t4,  rc          ' t4 is safe
  call         #doJemRETURN
  mov          rc,  t4          

  rdword       tp,  sp          ' special push
  add          tp,  jem
  call         #swap16  
  wrword       rc,  tp
  add          tp,  #2
  sub          tp,  jem
  wrword       tp,  sp

  jmp          #jvmDone         
}

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_RETURN
''  doJem_RETURN Meaning: Return (void) from method.
  call         #doJemRETURN
  jmp          #jvmDone

{{ kernel service  
doJemRETURN  
{
  JEM format: return
  method := jd.getJvmMP                          'current method
  size := (jd.readJavaByte(method + jd#JVM_PARAMETERS) & $7F) + jd.readJavaByte(method + jd#JVM_LOCALS) 'offset to saved mp,fp,pc in current frame
  sp := jd.getJvmFP + size
  jd.setJvmMP(jd.readJavaIntBE(sp))              'restore mp     
  fp := jd.readJavaIntBE(sp+2)
  jd.setJvmFP(fp)                                'restore fp
  jd.setJvmPC(jd.readJavaIntBE(sp+4))            'restore pc
  sp -= size
  jd.setJvmSP(sp)                                'restore sp
}
  'size = loadByte(mp+pcn#JVM_PARAMETERS)
  rdlong       rc,  mp
  add          rc,  #pcn#JVM_PARAMETERS
  call         #loadByte
  'size&= #$7f
  and          rc,  #$7f
  'size+= loadByte(mp + pcn#JVM_LOCALS)
  mov          t0,  rc  ' t0 = size
  rdlong       rc,  mp
  add          rc,  #pcn#JVM_LOCALS
  call         #loadByte
  add          t0,  rc
  'sp = fp + size
  rdlong       rc,  fp
  add          rc,  t0  ' t0 = size + parms + locals = method
  mov          t1,  rc  ' t1 = sp
  call         #loadWord
  wrlong       rc,  mp  ' restore mp
  'fp = loadWord(sp+2)
  mov          rc,  t1
  add          rc,  #2
  call         #loadWord
  wrlong       rc,  fp  ' restore fp
  'pc = loadWord(sp+4)
  mov          rc,  t1
  add          rc,  #4
  call         #loadWord
  wrlong       rc,  pc  ' restore pc
  'sp -= size
  sub          t1,  t0
  wrlong       t1,  sp  ' restore sp
doJemRETURN_ret ret    
}}

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_INVOKEVIRTUAL
''  doJem_INVOKEVIRTUAL Meaning: Invoke method based on runtime type.
{
  JEM format: invokevirtual,byte1,byte2
  byte2 is offset to begin of class method table (so if byte = $2D and class method table = $60, method header = $8D)
  byte1 is offset to sp to find object reference (so if sp = $3FF6 and byte1 = $04 then the aref is at $3FF6-$04 = $3FF2)

  sp := jd.getJvmSP                                       'get sp
  aref := jd.readJavaByte(jd.getJvmPC+1)                  'get offset from sp where aref is stored
  fp := sp - aref                                         'calculate address of possibly new frame
  aref := jd.readJavaIntBE(fp)                            'get aref
  if aref <> 0
    class := jd.readJavaIntBE(aref)                         'get address of class descriptor
    method := jd.readJavaByte(jd.getJvmPC+2) + class        'get address of method descriptor
    if jd.readJavaByte(method + jd#JVM_FLAGS) == $00        'not native
      sp += jd.readJavaByte(method + jd#JVM_LOCALS)         'skip locals     
      jd.writeJavaIntBE(sp,jd.getJvmMP)                     'save old mp
      jd.writeJavaIntBE(sp+2,jd.getJvmFP)                   'save old fp
      jd.writeJavaIntBE(sp+4,jd.getJvmPC+3)                 'save old pc (= return address)
      jd.setJvmSP(sp+6)                                     'set new sp     
      jd.setJvmMP(method)                                   'set new mp
      jd.setJvmFP(fp)                                       'set new fp
      jd.setJvmPC(jd.readJavaIntBE(method + jd#JVM_CODE))   'set new pc
      return -1
    if jd.readJavaByte(method + jd#JVM_FLAGS) == $80        'native
      nf := jd.readJavaIntBE(method + jd#JVM_CODE)          'get native function number
      return nf 'native function is executed from mainloop
  else
    je.throw(je#kNullPointerException)
    return -1
}
'  aref := jd.readJavaByte(jd.getJvmPC+1)                  'get offset from sp where aref is stored
  call         #loadBytePcPlus1
  mov          t2,  rc      ' t2 = aref offset

'  sp := jd.getJvmSP                                       'get sp
  rdlong       rc,  sp      ' t4 = sp
  mov          t4,  rc      ' t4 = sp

'  fp := sp - aref offset                                  'calculate address of new frame
  'mov          rc,  t4      ' rc = t4 = sp
  sub          rc,  t2      ' fp = rc = sp - aref offset
  
'  aref := jd.readJavaIntBE(fp)                            'get aref
  mov          t3,  rc      ' t3 = fp
  call         #loadWord

  'tjz          rc,  #throwINVOKEVIRTUAL
{
  cmp          rc,      #0      wz
  if_z         call    #branch
  long  $1ff & (throwINVOKEVIRTUAL-$)
}
'  if aref <> 0
'    class := jd.readJavaIntBE(aref)                       'get address of class descriptor
  rdlong       t1,  hp      ' get heap
  cmp          rc,  t1 wz,wc' if aref >= heap
  if_ae sub    rc,  jem     ' get aref no jem offset
  mov          t2,  rc      ' t2 = aref
  call         #loadWord
  'if_ae call   #swap16
  mov          t1,  rc      ' t1 = class
'    method := jd.readJavaByte(jd.getJvmPC+2) + class        'get address of method descriptor
  rdlong       rc,  pc
  add          rc,  #2
  call         #loadByte
  add          rc,  t1      ' + class
'    if jd.readJavaByte(method + jd#JVM_FLAGS) == $00        'not native
  mov          t2,  rc      ' t2 = method

  tjz          t3,  #throwINVOKEVIRTUAL                      ' do here to have method in t2

  add          rc,  #pcn#JVM_FLAGS
  call         #loadByte
  tjnz         rc,  #nativeINVOKEVIRTUAL


  jmp          #NewStackFrame
{
'      sp += jd.readJavaByte(method + jd#JVM_LOCALS)         'skip locals
  mov          rc,  t2
  add          rc,  #pcn#JVM_LOCALS   
  call         #loadByte    ' local count  
  add          t4,  rc      ' add to sp
'      jd.writeJavaIntBE(sp,jd.getJvmMP)                     'save old mp
  mov          arg1,t4      ' arg1 = sp + pcnt ... sp+0
  rdlong       rc,  mp      ' save old mp
  call         #saveWord    ' save old mp in sp
'      jd.writeJavaIntBE(sp+2,jd.getJvmFP)                   'save old fp
  add          arg1,#2      ' arg1 = sp + pcnt +2 ... sp+2
  rdlong       rc,  fp      ' save fp
  call         #saveWord    ' save old fp in sp
'      jd.writeJavaIntBE(sp+4,jd.getJvmPC+3)                 'save old pc (= return address)
  add          arg1,#2      ' arg1 = sp + pcnt +4 ... sp+4
  rdlong       rc,  pc
  add          rc,  #3      ' save pc+3 ... return address
  call         #saveWord
'      jd.setJvmSP(sp+6)                                     'set new sp     
  add          arg1,#2      ' sp + 6
  wrlong       arg1,sp      ' save sp + 6
'      jd.setJvmFP(fp)                                       'set new fp
  wrlong       t3,  fp      ' t3 = fp
'      jd.setJvmMP(method)                                   'set new mp
  wrlong       t2,  mp      ' t2 = method
'      jd.setJvmPC(jd.readJavaIntBE(method + jd#JVM_CODE))   'set new pc
  mov          rc,  t2      ' t2 = method
  add          rc, #pcn#JVM_CODE
  call         #loadWord
  wrlong       rc, pc       ' save pc  
'      return -1
  jmp          #jvmDone
'}

nativeINVOKEVIRTUAL
'    if jd.readJavaByte(method + jd#JVM_FLAGS) == $80        'native
'      nf := jd.readJavaIntBE(method + jd#JVM_CODE)          'get native function number
'      return nf 'native function is executed from mainloop
  ' method is native
  mov          rc,  t2      ' t2 = method
  add          rc, #pcn#JVM_CODE
  call         #loadWord
  add          rc,  #NATIVE_BIT ' bit flags native command
  wrlong       rc,  cmdp        ' set native command
  jmp          #jvmDone
throwINVOKEVIRTUAL
'  else
'    je.throw(je#kNullPointerException)
'    return -1
  mov          rc,EXCPTN
  wrlong       rc,cmdp        ' set exception command
endINVOKEVIRTUAL  
  jmp          #jvmDone


long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_INVOKESTATIC
''  doJem_INVOKESTATIC Meaning: Invoke a class (static) method.
{
  JEM format: invokestatic,byte1,byte2
  byte1 and byte2 form 16bits address to method header: addr = (byte1<<8)|(byte2) 

  sp := jd.getJvmSP                                       'get sp
  method := jd.readJavaIntBE(jd.getJvmPC+1)               'get address of method descriptor
  fp := sp - (jd.readJavaByte(method + jd#JVM_PARAMETERS) & $7F)  'calculate address of possible new frame (mask out exception bit)
  if jd.readJavaByte(method + jd#JVM_FLAGS) == $00        'not native
    sp += jd.readJavaByte(method + jd#JVM_LOCALS)         'skip locals     
    jd.writeJavaIntBE(sp,jd.getJvmMP)                     'save old mp
    jd.writeJavaIntBE(sp+2,jd.getJvmFP)                   'save old fp
    jd.writeJavaIntBE(sp+4,jd.getJvmPC+3)                 'save old pc (= return address)
    jd.setJvmFP(fp)                                       'set new fp
    jd.setJvmMP(method)                                   'set new mp
    jd.setJvmSP(sp+6)                                     'set new sp     
    jd.setJvmPC(jd.readJavaIntBE(method + jd#JVM_CODE))   'set new pc
    return -1
  if jd.readJavaByte(method + jd#JVM_FLAGS) == $80        'native
    nf := jd.readJavaIntBE(method + jd#JVM_CODE)          'get native function number
    return nf 'native function is executed from mainloop
}
'  method := jd.readJavaIntBE(jd.getJvmPC+1)               'get address of method descriptor

  call         #loadWordPcPlus1
  mov          t0,  rc      ' t0 = method
'  fp := sp - (jd.readJavaByte(method + jd#JVM_PARAMETERS) & $7F)  'calculate address of possible new frame (mask out exception bit)
  add          rc,  #pcn#JVM_PARAMETERS
  call         #loadByte
  mov          t2,  rc      ' t2 = parameter count
  and          t2,  #$7f
'  sp := jd.getJvmSP                                       'get sp
  rdlong       rc,  sp      ' get sp
  mov          t4,  rc      ' t4 = sp
'  fp := sp - parameter count
  sub          rc,  t2      ' rc = fp = sp - t2 parm count
  mov          t3,  rc      ' t3 = fp
  mov          rc,  t0      ' t0 = method
  mov          t2,  t0      ' t2 = method
'  if jd.readJavaByte(method + jd#JVM_FLAGS) == $00        'not native
  add          rc,  #pcn#JVM_FLAGS
  call         #loadByte    
'  if not zero, native
  cmp          rc,  #0   wz ' if flags != 0, method is native
  if_nz jmp    #nativeINVOKESTATIC

  jmp          #NewStackFrame
{
'    sp += jd.readJavaByte(method + jd#JVM_LOCALS)         'skip locals
  mov          rc,  t2      ' t2 = method
  add          rc,  #pcn#JVM_LOCALS   
  call         #loadByte    ' local count
  add          t4,  rc      ' add to sp  t4 = sp
'    jd.writeJavaIntBE(sp,jd.getJvmMP)                     'save old mp
  mov          arg1,t4      ' arg1 = sp + pcnt
  rdlong       rc,  mp                           
  call         #saveWord    ' save old MP in sp
'    jd.writeJavaIntBE(sp+2,jd.getJvmFP)                   'save old fp
  add          arg1,#2      ' arg1 = sp + pcnt + 2
  rdlong       rc,  fp
  call         #saveWord    ' save old FP in sp+2
'    jd.writeJavaIntBE(sp+4,jd.getJvmPC+3)                 'save old pc (= return address)
  add          arg1,#2      ' arg1 = sp + pcnt + 4
  rdlong       rc,  pc
  add          rc,  #3
  call         #saveWord    ' save old PC+3 in sp+4 ... return address
'    jd.setJvmSP(sp+6)                                     'set new sp     
  add          arg1,#2      ' arg1 = sp + pcnt + 6
  wrlong       arg1,sp      ' save sp+6
'    jd.setJvmFP(fp)                                       'set new fp
  wrlong       t3,  fp      ' save fp
'    jd.setJvmMP(method)                                   'set new mp
  mov          rc,  t2      ' t2 = method 
  wrlong       rc,  mp      ' save mp
'    jd.setJvmPC(jd.readJavaIntBE(method + jd#JVM_CODE))   'set new pc
  add          rc, #pcn#JVM_CODE
  call         #loadWord    ' get method + code
  wrlong       rc,  pc      ' set new pc  
'    return -1
  jmp          #jvmDone
'}

'  if jd.readJavaByte(method + jd#JVM_FLAGS) == $80        'native
nativeINVOKESTATIC
  ' method is native
'    nf := jd.readJavaIntBE(method + jd#JVM_CODE)          'get native function number
  mov          rc,  t2      ' t2 = method
  add          rc, #pcn#JVM_CODE
  call         #loadWord
'    return nf 'native function is executed from mainloop
  add          rc,  #NATIVE_BIT       ' bit flags native command
  wrlong       rc,  cmdp        ' set native command
  jmp          #jvmDone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_GETSTATIC
''  doJem_GETSTATIC Meaning: Get 32-bit static field from class.
{
  JEM format: getstatic,byte1,byte2
  byte1 and byte2 form 16bits offset into static variables area: offset = (byte1<<8)|(byte2) 

  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  value := jd.getStatic(offset)
  js.push(value) 'return value
  jd.incJvmPC(3)
}  
'  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  call         #loadWordPcPlus1
  mov          arg1,rc      ' arg1 = offset
'  value := jd.getStatic(offset)
  call         #getStatic   ' rc = value
'  js.push(value) 'return value
'  jd.incJvmPC(3)
  jmp          #pushIncrPC3done

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_PUTSTATIC
''  doJem_PUTSTATIC Meaning: Set 32-bit static field in class.
{
  JEM format: putstatic,byte1,byte2
  byte1 and byte2 form 16bits offset into static variables area: offset = (byte1<<8)|(byte2) 

  value := js.pop 'get value
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  jd.putStatic(offset,value)
  jd.incJvmPC(3)
}
'  value := js.pop 'get value
  call         #pop
  mov          t1,  rc      ' t1 = value
'  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  call         #loadWordPcPlus1
  mov          arg1,rc      ' arg1 = offset
  mov          rc,  t1
'  jd.putStatic(offset,value)
  call         #setStatic
'  jd.incJvmPC(3)
  jmp          #incrPC3done

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
''  doJem_NotUsed Meaning: Handle unused bytecode.

doJem_NotUsed
  jmp          #jvmDone


long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_POP
'doc  doJem_POP Meaning: Pop the top word from the stack.
{
  JEM format: pop
  val := pop
  jd.incJvmPC(1)
  return val   ' not used in jvmEngine
}
  call         #pop
  jmp          #incrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_POP2
'doc  doJem_POP2 Meaning: Pop the top two words from the stack.
{
  JEM format: pop2
  w1 := pop  'lsw
  w2 := pop  'msw
  jd.incJvmPC(1)
  return (w2 << 16) | w1  'return 32bits result ' not used in jvmEngine
}
  call         #pop
  mov          t0,  rc   ' w1 = lsw
  call         #pop    
  shl          rc,  #16  ' w2 = msw
  or           rc,  t0
  jmp          #incrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_DUP
'doc  doJem_DUP Meaning: Duplicate the top word on the stack.
{
  JEM format: dup
  w1 := pop
  push(w1)
  push(w1)
  jd.incJvmPC(1)
}
  call         #pop
  call         #push
  jmp          #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_DUP_X1
'doc  doJem_DUP_X1 Meaning: Duplicate the top word on the stack and insert a copy two words down in the stack.
{
  JEM format: dup_x1
  w1 := pop
  w2 := pop
  push(w1)
  push(w2)
  push(w1)
  jd.incJvmPC(1)
}
  call         #pop1
  call         #pop2
  jmp          #push121_incrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_DUP_X2
'doc  doJem_DUP_X2 Meaning: Duplicate the top word on the stack and insert the copy three words down in the stack.
{
  JEM format: dup_x2
  w1 := pop
  w2 := pop
  w3 := pop
  push(w1)
  push(w3)
  push(w2)
  push(w1)
  jd.incJvmPC(1)
}
  call         #pop1
  call         #pop2
  call         #pop3
  call         #push1
  jmp          #push321_incrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_DUP2
'doc  doJem_DUP2 Meaning: Duplicate the top two words on the stack.
{
  JEM format: dup2
  w1 := pop
  w2 := pop
  push(w2)
  push(w1)
  push(w2)
  push(w1)
  jd.incJvmPC(1)
}
  call         #pop1
  call         #pop2
  jmp          #push2121_incrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_DUP2_X1
'doc  doJem_DUP2_X1 Meaning: Duplicate the top two words on the stack and insert the copies two words down in the stack.
{
  JEM format: dup2_x1

  w1 := pop
  w2 := pop
  w3 := pop
  push(w2)
  push(w1)
  push(w3)
  push(w2)
  push(w1)
  jd.incJvmPC(1)
}
  call         #pop1
  call         #pop2
  call         #pop3
  call         #push2
  call         #push1
  jmp          #push321_incrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_DUP2_X2
'doc  doJem_DUP2_X2 Meaning: Duplicate the top two words on the stack and insert the copies three words down in the stack.
{
  JEM format: dup2_x2

  w1 := pop
  w2 := pop
  w3 := pop
  w4 := pop
  push(w2)
  push(w1)
  push(w4)
  push(w3)
  push(w2)
  push(w1)
  jd.incJvmPC(1)
}
  call         #pop1
  call         #pop2
  call         #pop3
  call         #pop4
  jmp          #push214321_incrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_SWAP
'doc  doJem_SWAP Meaning: Swap the top two elements on the stack.
{
  JEM format: swap

  w1 := pop
  w2 := pop
  push(w1)
  push(w2)
  jd.incJvmPC(1)
}
  call         #pop1
  call         #pop2
  jmp          #push21_incrPCdone

{ kernel service
push2121_incrPCdone
  call         #push2
push121_incrPCdone
  call         #push1
push21_incrPCdone
  call         #push2
  call         #push1
  jmp          #incrPCdone

push214321_incrPCdone
  call         #push2
  call         #push1
push4321_incrPCdone
  call         #push4
push321_incrPCdone
  call         #push3
  call         #push2
  call         #push1
  jmp          #incrPCdone
}

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IADD
'doc  doJem_IADD Meaning: Integer add.
{                                                                                    
  JEM format: iadd

  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  w1 := w1 + w2
  jd.clearCarry
  if w1 < -32768 OR w1 > 32767
    jd.setCarry
}
'{
  call         #pop2signed    ' arg1 = w2, arg2 = w1
  add          arg2,  arg1 wc
  if_nc wrlong one,   cp   'call   #setCarry
  if_c  wrlong zero,  cp   'call   #clrCarry
  and          arg2,  Minus1  
  jmp          #mvRcIncrPCdone
'}

{ works about the same
  call         #poparg12     ' arg1 = w2, arg2 = w1
  add          arg2,  arg1
  test         arg2,  M1WDXT wz
  if_z  wrlong one,   cp   'call   #setCarry
  if_nz wrlong zero,  cp   'call   #clrCarry
  and          arg2,  Minus1  
  jmp          #mvRcIncrPCdone
'}

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ISUB
''  doJem_ISUB Meaning: Integer subtract.
{
  JEM format: isub

  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  w1 := w1 - w2
  jd.clearCarry
  if w1 < -32768 OR w1 > 32767
    jd.setCarry
  js.push(w1)
  jd.incJvmPC(1)
}

{
  call         #poparg12     ' arg1 = w2, arg2 = w1
  sub          arg2,  arg1  wc
  if_c  wrlong one,   cp   'call   #setCarry
  if_nc wrlong zero,  cp   'call   #clrCarry
  and          arg2,  Minus1  
  jmp          #mvRcIncrPCdone
'}

'{
  call         #pop2signed   ' arg1 = w2, arg2 = w1
  sub          arg2,  arg1  wc    ' result of sign extend should be correct carry
  if_c  wrlong one,   cp   'call   #setCarry
  if_nc wrlong zero,  cp   'call   #clrCarry
  and          arg2,  Minus1  
  jmp          #mvRcIncrPCdone
'}

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_INEG
''  doJem_INEG Meaning: Integer negate.
{
  JEM format: ineg

  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  w1 := -w1
  js.push(w1)
  jd.incJvmPC(1)
}
  call         #pop
  cmp          rc,  #0 wz
  if_z jmp     #pushIncrPCdone
  and          rc,  MINUS1  ' 16 bits
  xor          rc,  MINUS1  ' invert
  add          rc,  #1        ' java uses two's complement
  jmp          #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IOR
''  doJem_IOR Meaning: Integer bitwise or.
{
  JEMformat: ior

  w2 := js.pop
  w1 := js.pop
  w1 |= w2
  js.push(w1)
  jd.incJvmPC(1)
}
  call         #poparg12
  or           arg2,arg1   ' w1,w2
  jmp          #mvRcIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ISHL
''  doJem_ISHL Meaning: Integer shift left.
{
  JEM format: ishl

  w2 := js.pop
  w1 := js.pop
  w1 <<= w2
  js.push(w1)
  jd.incJvmPC(1)
}

{
  call         #poparg12
  and          arg1,#$1f
  mov          rc,  arg2
  call         #signExtend16
  shl          rc,arg1
  test         rc,Minus1    wz
  if_nz wrlong one, cp      ' set carry  
  jmp          #pushIncrPCdone
'}
'{
  call         #pop2signed
  and          arg1,#$1f
  shl          arg2,arg1    ' w1,w2
  test         rc,Minus1    wz
  if_nz wrlong one, cp      ' set carry  
  jmp          #mvRcIncrPCdone   
'}

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ISHR
''  doJem_ISHR Meaning: Integer arithmetic shift right.
{
  JEM foramt: ishr

  w2 := js.pop
  w1 := js.pop
  w1 ~>= w2
  js.push(w1)
  jd.incJvmPC(1)
}
{
  call         #poparg12
  and          arg1,#$1f
  mov          rc,  arg2
  call         #signExtend16
  sar          rc,arg1
  jmp          #pushIncrPCdone
'}
'{
  call         #pop2signed
  and          arg1,#$1f
  sar          arg2,arg1    ' w1,w2
  jmp          #mvRcIncrPCdone
'}
long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IUSHR
''  doJem_IUSHR Meaning: Integer logical shift right.
{                 
  JEM format: iushr

  w2 := js.pop
  w1 := js.pop
  w1 >>= w2
  js.push(w1)
  jd.incJvmPC(1)
}  
  call         #poparg12
  and          arg1,#$1f
  shr          arg2,arg1
  jmp          #mvRcIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IAND
''  doJem_IAND Meaning: Integer bitwise and.
{
  JEM format: iand

  w2 := js.pop
  w1 := js.pop
  w1 &= w2
  js.push(w1)
  jd.incJvmPC(1)
}
  call         #poparg12
  and          arg2,arg1
  jmp          #mvRcIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IXOR
''  doJem_IXOR Meaning: Integer bitwise xor.
{
  JEM format: ixor

  w2 := js.pop
  w1 := js.pop
  w1 ^= w2
  js.push(w1)
  jd.incJvmPC(1)
}
  call         #poparg12
  xor          arg2,arg1
  jmp          #mvRcIncrPCdone

{ kernel service
mvRcIncrPCdone
  mov          rc,  arg2
  jmp          #pushIncrPCdone
}


long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_I2B
''  doJem_I2B Meaning: Integer to signed byte.
{
  JEM format: i2b

  w1 := js.pop
  w1 &= $FF
  js.push(w1)
  jd.incJvmPC(1)
}
  call         #pop
  and          rc,  #$ff
  jmp          #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_GOTO
''  doJem_GOTO Meaning: Branch.
{
  Description: Execution proceeds at the signed 16-bit offset from the address of this instruction.
  The offset is constructed from byte1 and byte2.


  JEM format: goto,byte1,byte2
  byte1 and byte2 form 16bits offset to add to pc: offset = (byte1<<8)|(byte2) 

  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  jd.incJvmPC(offset)
}
  call         #loadWordPcPlus1
'  call         #addPC
  call         #signExtend16
  rdlong       tp, pc
  add          tp, rc
  wrlong       tp, pc
  jmp          #jvmDone
  
long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_INVOKEINTERFACE           ' appears to be unused
  jmp          #jvmDone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ARRAYLENGTH
'' doJem_ARRAYLENGTH Meaning: Get length of array.
{
  Description: The length of the array is determined and replaces aref on the top of the stack. 
  The aref must be a reference to an array object. 
  Note:
  A NullPointerException is thrown if the aref is null.

  aref := js.pop 'get reference
  if aref <> 0
    len := jd.readJavaIntBE(aref + 2)
    js.push(len)
    jd.incJvmPC(1)
  else
    je.throw(je#kNullPointerException)
}
'  aref := js.pop 'get reference
  call         #pop
'  if aref == 0
'    je.throw(je#kNullPointerException)
  tjz          rc,  #alenException
{
  cmp          rc,  #0 wz
  if_z  jmp    #alenException
}
{
  if_z         call     #branch
  long  $1ff & (alenException-$)
}
  rdlong       t2,  hp  ' get heap
  cmp          rc,  t2 wz,wc ' if aref >= heap
  if_ae sub    rc,  jem ' get aref no jem offset
'  if aref <> 0
  add          rc,  #2
'    len := jd.readJavaIntBE(aref + 2)
  call         #loadWord
'    js.push(len)
'    jd.incJvmPC(1)
  jmp          #pushIncrPCdone
alenException
  mov          rc,  EXCPTN    
  wrlong       rc,  cmdp
  jmp          #jvmDone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ATHROW
'' doJem_ATHROW Meaning: Throw exception or error.
{
  The objectref must be of type reference and must refer to an object that is an instance of class Throwable or
  of a subclass of Throwable. It is popped from the operand stack. The objectref is then thrown by searching the
  current method for the first exception handler that matches the class of objectref.
  If an exception handler that matches objectref is found, it contains the location of the code intended to handle
  this exception. The pc register is reset to that location, the operand stack of the current frame is cleared,
  objectref is pushed back onto the operand stack, and execution continues. 
  If no matching exception handler is found in the current frame, that frame is popped. If the current frame
  represents an invocation of a synchronized method, the monitor acquired or reentered on invocation of the method
  is released or exited (respectively) as if by execution of a monitorexit instruction.
  Finally, the frame of its invoker is reinstated, if such a frame exists, and the objectref is rethrown.
  If no such frame exists, the current thread exits.
}
{
  JEM format: athrow

  aref := js.pop 'get objectref
  'throwException(aref)
  'Auxiliary function (no bytecode): Throw an exception
  if e <> 0
    if jd.getJvmEP == 0
      jd.setJvmEP(jd.getJvmPC) 'set exception if not already set
    repeat
      exceptionTable := jd.readJavaIntBE(jd.getJvmMP + jd#JVM_EXCEPTION) 'get address of exception table
      numExceptions := 0
      if exceptionTable <> 0
        numExceptions := jd.readJavaByte(exceptionTable) 'read number of exception handlers
      index := 0
      repeat while numExceptions > 0
        if jd.getJvmPC => jd.readJavaIntBE(exceptionTable + 1 + index) AND jd.getJvmPC < jd.readJavaIntBE(exceptionTable + 3 + index)
          if instanceOf(e,jd.readJavaIntBE(exceptionTable + 5 + index))
            'clear operand stack
            paramsize := (jd.readJavaByte(jd.getJvmMP + jd#JVM_PARAMETERS) & $7F) 'mask out exception bit
            localsize := jd.readJavaByte(jd.getJvmMP + jd#JVM_LOCALS)
            sp := jd.getJvmFP + paramsize + localsize + 6
            jd.setJvmSP(sp)
            'push exception
            js.push(e)
            'jump to handler
            pc := jd.readJavaIntBE(exceptionTable + 7 + index)
            jd.setJvmPC(pc)
            return
        index += 8 'size of exception record
        numExceptions--
      jsub.jb_return  'pop frame
    until jd.getJvmMP == $FFFF
    class := jd.readJavaIntBE(e)
    comm.errException(class,jd.getJvmEP) 'signal exception to IDE
    jd.setJvmEP(0) 'clear exception
  else
    throw(kNullPointerException)  
}
  jmp          #jvmDone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_CHECKCAST
'' doJem_CHECKCAST Meaning: Make sure object is of given type.
{
  Description: Determines whether the referenced object can be cast to be a reference to an 
  object of another class. A null object reference can be cast to any class. Otherwise, the 
  referenced object must be an instance of the expected class or one of its superclasses. byte1  
  and byte2 are used to construct an index into the constant pool of the current class, which is 
  presumed to be a class name that can be resolved to a class pointer. 
  Note:
  A ClassCastException is thrown if the referenced object cannot be cast to the expected class.

  JEM format: checkcast,byte1,byte2
  byte1 and byte2 are always 0 (so this bytecode does not do anything)

  jd.incJvmPC(3)
}
  jmp          #incrPC3done

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_INSTANCEOF
'' doJem_INSTANCEOF Meaning: Determine if an object is of given type and return result.
{
  Description: Determines whether the referenced object can be cast to be a reference to an 
  object of the expected class. This instruction will overwrite the object reference with 1 if the 
  object is an instance of the expected class or one of its superclasses. Otherwise, the object 
  reference is overwritten by 0.
 
  JEM format: instanceof,byte1,byte2
  byte1 and byte2 form 16bits offset to class header: offset = (byte1<<8)|(byte2) 

  instance := js.pop 'get instance reference
  class := jd.readJavaIntBE(jd.getJvmPC+1) 'class type
  instanceclass := jd.readJavaIntBE(instance) 'get class type for instance
  repeat
    if instanceclass == class
      js.push(1)
      jd.incJvmPC(3)
      return
    else
      instanceclass := jd.readJavaIntBE(instanceclass) 'get superclass of instance
  until instanceclass == $FFFF '$FFFF is superclass of Object class
  js.push(0)
  jd.incJvmPC(3)
}
  call         #pop
  mov          t0,  rc  ' t0 = instance
  call         #loadWordPcPlus1
  mov          t1,  rc  ' t1 = class
  mov          rc,  t0
  call         #loadWord
  mov          t2,  rc  ' t2 = instanceclass
loopINSTANCEOF
  cmp          t1,  t2 wz
  if_z  mov    rc,  #1
  if_z  call   #push
  if_z  jmp    #incrPC3done
  mov          rc,  t2
  call         #loadWord
  cmp          rc, MINUS1 wz
  if_nz jmp    #loopINSTANCEOF
{
  if_nz jmp    #branch
  long  $1ff & ($-@loopINSTANCEOF)
}
  mov          rc,  #0
  'call         #push
  jmp          #pushIncrPC3done



  
long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
' 
doJem_WIDE                  ' not used
  jmp          #jvmDone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IINC
'' doJem_IINC Meaning: Increment local variable by constant.
{
  JEM format: iinc,byte1,byte2
  byte1 is the index of the local variable. byte2 is the signed 1byte value to add to local variable.
  index := jd.readJavaByte(jd.getJvmPC+1)
  val := jd.readJavaByte(jd.getJvmPC+2)
  val := jc.b2i(val)
  fp := jd.getJvmFP
  val += jd.readJavaIntBE(fp + (index<<1))
  jd.writeJavaIntBE(fp + (index<<1),val)
  jd.incJvmPC(3)
}
'  index := jd.readJavaByte(jd.getJvmPC+1)
  call         #loadBytePcPlus1
  mov          t0,  rc      ' t0 = index
'  val := jd.readJavaByte(jd.getJvmPC+2)
  rdlong       rc,  pc
  add          rc,  #2
  call         #loadByte
'  val := jc.b2i(val)
  test         rc,  MSB8 wz
  if_nz or     rc,  M1BXT  ' byte extend
  mov          t1,  rc      ' val
'  fp := jd.getJvmFP
  rdlong       rc,  fp
'  val += jd.readJavaIntBE(fp + (index<<1))
  shl          t0,  #1        ' index<<1
  add          rc,  t0      ' address to load
  'adds         rc,  t0      ' address to load ... can't use adds with 16bit JVM
  mov          t0,  rc      ' t0 = fp+(index<<1)
  call         #loadWord  
  add          rc,  t1      ' val += loadword
'  jd.writeJavaIntBE(fp + (index<<1),val)
  mov          arg1,t0
  call         #saveWord
'  jd.incJvmPC(3)
  jmp          #incrPC3done

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_GETFIELD
'' doJem_GETFIELD Meaning: Fetch 32-bit field from object.
{
  JEM format: getfield,byte1,byte2
  byte1 and byte2 form 16bits offset into object instance on heap: offset = (byte1<<8)|(byte2) 

  aref := js.pop  'get reference ... if it's > hp, sub jem
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  value := jd.readJavaIntBE(aref + offset)
  js.push(value) 'return value
  jd.incJvmPC(3)
}
'' GETFIELD reads from classes or objects. Classes are stored in read-only space < heap.
'' Objects are stored in heap. We have to adjust for class data by jem offset.
'' This smells like a huge hack, and would be better if everything was relative to jem offset.
''
'  aref := js.pop  'get reference
  call         #pop
  rdlong       t2,  hp  ' get heap
  cmp          rc,  t2 wz,wc ' if aref >= heap
  jmp          #doJemGETFIELD
{
  if_ae sub    rc,  jem ' get aref no jem offset
  mov          t0,  rc  ' t0 = aref
'  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  call         #loadWordPcPlus1
  add          rc,  t0  ' offset + aref
'  value := jd.readJavaIntBE(aref + offset)
  call         #loadWord
  'if_ae call   #swap16                                                                                    
  jmp          #pushIncrPC3done
}
long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_PUTFIELD
'' doJem_PUTFIELD Meaning: Set 32-bit field in object.
{
  JEM format: putfield,byte1,byte2
  byte1 and byte2 form 16bits offset into object instance on heap: offset = (byte1<<8)|(byte2) 

  value := js.pop 'get value
  aref := js.pop  'get reference
  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  jd.writeJavaIntBE(aref + offset,value)
  jd.incJvmPC(3)
}
'' PUTFIELD only saves to heap, so we can ignore jem offset  ??? 
  call         #pop
  mov          t0,  rc  ' t0 = value
  call         #pop
  sub          rc,  jem ' get aref no jem offset
  mov          t1,  rc  ' t1 = aref
  call         #loadWordPcPlus1
  
  'rdlong       t2,  hp  ' get heap
  'cmp          rc,  t2 wz,wc ' if aref >= heap
  'if_b  sub    rc,  jem ' get aref no jem offset
  'sub          rc,  jem ' get aref no jem offset
  
  add          t1,  rc  ' t1 = aref + offset
  mov          arg1,t1  ' aref+offset
  mov          rc,  t0  ' value
  'if_ae call   #swap16
  call         #saveWord
  jmp          #incrPC3done


long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_NEW
'' doJem_NEW Meaning: Create new object.
{
  Description: byte1 and byte2 are used to construct an index into the constant pool of the 
  current class, which must be a class name that can be resolved to a class pointer. A new 
  instance of that class is then created, and a reference to the object is pushed on the stack.
 
  JEM format: new,byte1,byte2
  byte1 and byte2 form 16bits offset to class descriptor: class = (byte1<<8)|(byte2) 

  class := jd.readJavaIntBE(jd.getJvmPC+1)
  size := jd.readJavaByte(class + jd#JVM_FIELDS) 'get size of non-static non-final variables
  aref := jh.allocate(size + 2) 'add 2 for class reference
  if aref <> 0
    jd.writeJavaIntBE(aref,class)
    i := 2
    repeat size 'clear databytes
      jd.writeJavaByte(aref+i,$00)
      i++
    js.push(aref) 'push reference to instance
    jd.incJvmPC(3)
  else
    je.throw(je#kOutOfMemoryError)
}
'  class := jd.readJavaIntBE(jd.getJvmPC+1)
  call         #loadWordPcPlus1
  mov          t0,  rc      ' t0 = class
'  size := jd.readJavaByte(class + jd#JVM_FIELDS) 'get size of non-static non-final variables
  add          rc,  #pcn#JVM_FIELDS
  call         #loadByte
  mov          t1,  rc      ' t1 = size
'  aref := jh.allocate(size + 2) 'add 2 for class reference
  add          rc,  #2
  mov          arg1,rc
  call         #allocate
  tjz          rc,  #memExcptnNEW
{
  cmp          rc,  #0 wz
' if_z  jmp    #memExcptnNEW
  if_z  call   #branch
  long  $1ff & (memExcptnNEW-$)
}
'  if aref <> 0
'    jd.writeJavaIntBE(aref,class)
  mov          t2,  rc      ' t2 = aref ... save for later
  sub          t2,  jem     ' save aref no jem offset
  mov          arg1,t2
  mov          rc,  t0      ' t0 = class
  call         #saveWord
'{
'    i := 2
  sub          t1,  #1 wz,wc
  if_be jmp    #clrDone
{
  if_be call   #branch
  long  $1ff & (clrDone-$)
}
  add          t1,  #1      ' add back so we clear all of new block
  mov          t3,  #2      ' index
'    repeat size 'clear databytes t1 = size
clrNEW
'      jd.writeJavaByte(aref+i,$00)
  mov          arg1,t2
  add          arg1,t3
  mov          rc,  #0
  call         #saveByte
'      i++
  add          t3,  #1
  djnz         t1,  #clrNEW
{
  sub          t1, #1
  cmp          t1, #0 wz
  if_nz call   #branch
  long  $1ff & (clrNEW-$)
}

'}
clrDone
'    js.push(aref) 'push reference to instance
  add          t2,  jem     ' push aref no jem offset
  mov          rc,  t2
'    jd.incJvmPC(3)
  jmp          #pushIncrPC3done
memExcptnNEW
'  else
'    je.throw(je#kOutOfMemoryError)
  rdlong       rc,  pc
  or           rc,  EXCPTN
  wrlong       rc,  cmdp        ' set exception command
  jmp          #jvmDone



long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_NEWARRAY
'' doJem_NEWARRAY Meaning: allocate new array.
{
  Description: A new array of a specific array type, capable of holding size elements, is allocated. The result
  is a reference to the new object. Allocation of an array large enough to contain size items of the specific
  array type is attempted and all elements of the array are initialized to 0.  
  size represents the number of elements in the new array and must be an integer. The result is stored with an
  internal code that indicates the type of array to allocate. Possible values for the type of array are as follows:
  T_BOOLEAN 4, T_CHAR 5, T_FLOAT 6, T_DOUBLE 7, T_BYTE 8, T_SHORT 9, T_INT 10, T_LONG 11
  Note:
  A NegativeArraySizeException is thrown if size is less than 0. 
  An OutOfMemoryError is thrown if there is not enough memory to allocate the array.
 
  jem format: newarray,byte1
  byte1 identifies type: 0 for short and int, 1 for boolean, byte and char. 

  len := js.pop 'pop length
  if len > 0
    type := jd.readJavaByte(jd.getJvmPC+1)
    size := len*(2-type)
    aref := jh.allocate(size + 4)
    if aref <> 0
      class := jd.readJavaIntBE(jd#JVM_OBJECT)
      jd.writeJavaIntBE(aref+0,class)
      jd.writeJavaIntBE(aref+2,len)
      i := 4
      repeat size 'clear array
        jd.writeJavaByte(aref+i,$00)
        i++
      js.push(aref) 'push reference
      jd.incJvmPC(2)
    else
      je.throw(je#kOutOfMemoryError)
  else
    je.throw(je#kIllegalArgumentException)
}
  call         #pop
  cmp          rc,  #0 wz,wc
  if_be jmp    #argExcptnNEWARRAY
{
  if_be call   #branch
  long  $1ff & (argExcptnNEWARRAY-$)
}
  mov          t0,  rc      ' t0 = len
  call         #loadBytePcPlus1
  mov          t1,  rc      ' t1 = type
  mov          t2,  #2
  sub          t2,  t1
  mov          arg1,t0
  mov          arg2,t2
  call         #multiply
  mov          t1,  rc      ' t1 = size
  add          rc,  #4
  mov          arg1,rc
  call         #allocate      ' clear new array further down
  mov          t2,  rc      ' t2 = aref
  sub          t2,  jem     ' get aref no jem offset
  cmp          rc,  #0 wz
  if_z  jmp    #memExcptnNEWARRAY
{
  if_z  call   #branch
  long  $1ff & (memExcptnNEWARRAY-$)
}
  mov          rc,  #pcn#JVM_OBJECT
  call         #loadWord
  mov          t3,  rc      ' t3 = class
  mov          arg1, t2
  mov          rc, t3               
  call         #saveWord  
  add          arg1, #2
  mov          rc, t0
  call         #saveWord
  mov          t4,  #4      ' t4 = index
  
clrNEWARRAY
  mov          arg1,t2
  add          arg1,t4      ' arg1 = aref+index
  mov          rc,  #0
  call         #saveByte
  add          t4,  #1

  djnz         t1, #clrNEWARRAY
{
  sub          t1, #1
  cmp          t1, #0 wz
  if_nz call   #branch
  long  $1ff & (clrNEWARRAY-$)
}
  add          t2,  jem     ' add back jem offset for aref on stack
  mov          rc,  t2      ' t2 = aref
  jmp          #pushIncrPC2done
memExcptnNEWARRAY
  mov          t0, x4000
argExcptnNEWARRAY      
  jmp          #exception
  
long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_ANEWARRAY
'' doJem_ANEWARRAY Meaning: allocate new array of objects.
{
  Description: A new array of the indicated class type and capable of holding size elements is allocated.
  The result is a reference to the new object. Allocation of an array large enough to contain size elements
  of the given class type is attempted and all elements of the array are initialized to null.  
  size represents the number of elements in the new array and must be an integer. byte1 and byte2
  are used to construct an index into the constant pool of the current class. When the item at that index
  is resolved, the resulting entry must be a class. 
  Note:
  A NegativeArraySizeException is thrown if size is less than 0. 
  An OutOfMemoryError is thrown if there is not enough memory to allocate the array.  

  The anewarray instruction is used to create a single-dimension array. For example, the declaration
  new Thread[7] generates the following bytecode instructions:  
    bipush 7 
    anewarray <Class "java.lang.Thread">
  The anewarray instruction can also be used to create the outermost dimension of a multidimensional array. 
  for example, the array declaration new int[6][] generates the following bytecode instructions:  
    bipush 6 
    anewarray <Class "[I">
 
  jem format: anewarray,byte1,byte2
  byte1 is always 0. byte2 identifies type: 0 for short, int and reference, 1 for boolean, byte and char.
  Since array of objects equals array of references, byte2 is always 0 too. 

  len := js.pop 'pop length
  if len > 0
    type := jd.readJavaByte(jd.getJvmPC+2)
    size := len*(2-type)
    aref := jh.allocate(size + 4)
    if aref <> 0
      class := jd.readJavaIntBE(jd#JVM_OBJECT)
      jd.writeJavaIntBE(aref+0,class)
      jd.writeJavaIntBE(aref+2,len)
      i := 4
      repeat size 'clear array
        jd.writeJavaByte(aref+i,$00)
        i++
      js.push(aref) 'push reference
      jd.incJvmPC(3)
    else
      je.throw(je#kOutOfMemoryError)
  else
    je.throw(je#kIllegalArgumentException)
}
  call         #pop
  cmp          rc,  #0 wz,wc
  if_be jmp    #argExcptnANEWARRAY
{
  if_be call   #branch
  long  $1ff & (argExcptnANEWARRAY-$)
}
  mov          t0,  rc      ' t0 = len
  rdlong       rc,  pc
  add          rc,  #2      ' only diff between this and NEWARRAY?
  call         #loadByte
  mov          t1,  rc      ' t1 = type
  mov          t2,  #2
  sub          t2,  t1
  mov          arg1,t0
  mov          arg2,t2
  call         #multiply
  mov          t1,  rc      ' t1 = size
  add          rc,  #4
  mov          arg1,rc
  call         #allocate
  mov          t2,  rc      ' t2 = aref
  sub          t2,  jem     ' get aref no jem offset
  cmp          rc,  #0 wz
  if_z  jmp    #memExcptnANEWARRAY
{
  if_z  call   #branch
  long  $1ff & (memExcptnANEWARRAY-$)
}
  mov          rc,  #pcn#JVM_OBJECT
  call         #loadWord
  mov          t3,  rc      ' t3 = class
  mov          arg1, t2
  mov          rc, t3
  call         #saveWord  
  add          arg1, #2
  mov          rc, t0
  call         #saveWord
  mov          t4,  #4      ' t4 = index
clrANEWARRAY
  mov          arg1,t2
  add          arg1,t4      ' arg1 = aref+index
  mov          rc,  #0
  call         #saveByte
  add          t4,  #1
  djnz         t1,  #clrANEWARRAY
{
  sub          t1, #1
  cmp          t1, #0 wz
  if_nz call   #branch
  long  $1ff & (clrANEWARRAY-$)
}
  add          t2,  jem     ' add back jem offset for aref on stack
  mov          rc,  t2
  jmp          #pushIncrPC3done
memExcptnANEWARRAY
  mov          t0, x4000
argExcptnANEWARRAY      
  jmp          #exception


long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IALOAD
'' doJem_IALOAD Meaning: Load integer from array.
{
  Description: The integer value at the array aref is retrieved and pushed onto the top of the stack.
  The index must be a reference to an array of integers; likewise, the index into the array must be an integer. 
  Note:
  A NullPointerException is thrown if aref is null. An ArrayIndexOutOfBoundsException is thrown if the array index
  is not within the bounds of the array.
 
  jem format: iaload

  index := js.pop 'get index
  aref := js.pop  'get reference
  if aref <> 0
    elements := jd.readJavaIntBE(aref + 2)
    if index => 0 AND index < elements
      val := jd.readJavaIntBE(aref + 4 + (index<<1))
      js.push(val)    'push value
      jd.incJvmPC(1)
    else
      je.throw(je#kIndexOutOfBoundsException)
  else
    je.throw(je#kNullPointerException)
}
  call         #pop
  mov          t0,  rc      ' t0 = index
  call         #pop
  'mov          t1,  rc      ' t1 = aref
  cmp          rc,  #0  wz
  if_z  jmp    #nullExcptnIALOAD
{
  if_z  call   #branch
  long  $1ff & (nullExcptnIALOAD-$)
}
  rdlong       t2,  hp  ' get heap
  cmp          rc,  t2 wz,wc ' if aref >= heap
  if_ae sub    rc,  jem ' get aref no jem offset
  mov          t1,  rc      ' t1 = aref

  add          rc,  #2        ' aref + 2
  'mov          t2,  rc      ' t2 = aref
  
  call         #loadWord
  mov          t2,  rc      ' t2 = elements
  cmp          t0,  #0 wz,wc
  if_b  jmp    #oobExcptnIALOAD ' if index < 0 throw OOB
{
  if_b  call   #branch
  long  $1ff & (oobExcptnIALOAD-$)
}
  cmp          t0,  t2 wz,wc
  if_ae jmp    #oobExcptnIALOAD ' if index >= elements throw OOB
{
  if_ae call   #branch
  long  $1ff & (oobExcptnIALOAD-$)
}
  mov          rc, t1       ' rc = aref
  add          rc, #4         ' rc = aref + 4
  shl          t0, #1         ' index << 1
  add          rc,  t0      ' rc = aref + 4 + index << 1
  call         #loadWord
  call         #swap16
  
  jmp          #pushIncrPCdone
oobExcptnIALOAD  
  mov          t0, x4000
nullExcptnIALOAD
  jmp          #exception

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IASTORE
'' doJem_IASTORE Meaning: Store into integer array.
{
  Description: An integer value is popped off the stack and stored in the array at the index. The aref must be
  a reference to an array of integer values, and the index into the array must be an integer as well.
 
  jem format: iastore

  val := js.pop   'get value
  index := js.pop 'get index
  aref := js.pop  'get reference
  if aref <> 0
    elements := jd.readJavaIntBE(aref + 2)
    if index => 0 AND index < elements
      jd.writeJavaIntBE(aref + 4 + (index<<1),val)
      jd.incJvmPC(1)
    else
      je.throw(je#kIndexOutOfBoundsException)
  else
    je.throw(je#kNullPointerException)
}
'  val := js.pop   'get value
  call         #pop
  mov          t3,  rc      ' t3 = value
'  index := js.pop 'get index
  call         #pop
  mov          t0,  rc      ' t0 = index
'  aref := js.pop  'get reference
  call         #pop

  rdlong       t2,  hp  ' get heap
  cmp          rc,  t2 wz,wc ' if aref >= heap
  if_ae sub    rc,  jem ' get aref no jem offset

  mov          t1,  rc      ' t1 = aref
'  if aref == 0  exception
  cmp          rc,  #0  wz
  if_z  jmp    #nullExcptnIASTORE
{
  if_z  call   #branch
  long  $1ff & (nullExcptnIASTORE-$)
}
'  if aref <> 0
'    elements := jd.readJavaIntBE(aref + 2)
  add          rc,  #2
  call         #loadWord
  mov          t2,  rc      ' t2 = elements

  cmp          t0,  #0 wz,wc
  if_b  jmp    #oobExcptnIASTORE
{
  if_b  call   #branch
  long  $1ff & (oobExcptnIASTORE-$)
}
  cmp          t0,  t2 wz,wc
  if_ae jmp    #oobExcptnIASTORE
{
  if_ae call   #branch
  long  $1ff & (oobExcptnIASTORE-$)
}
'    if index => 0 AND index < elements
'      jd.writeJavaIntBE(aref + 4 + (index<<1),val)
  mov          arg1,t1
  add          arg1,#4
  shl          t0,  #1
  add          arg1,t0
  mov          rc,  t3
  call         #swap16
  call         #saveWord
'      jd.incJvmPC(1)
  jmp          #incrPCdone
'    else
'      je.throw(je#kIndexOutOfBoundsException)
oobExcptnIASTORE  
  mov          t0, x4000
'  if aref == 0  exception
'    je.throw(je#kNullPointerException)
nullExcptnIASTORE
  jmp          #exception


long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_BALOAD
'' doJem_BALOAD Meaning: Load signed byte from array.
{
  Description: The signed byte value at the array index is retrieved, expanded to an integer, and pushed onto
  the top of the stack. The aref must be a reference to an array of signed byte values, and the index into the
  array must be an integer.
 
  jem format: baload

  index := js.pop 'get index
  aref := js.pop  'get reference
  if aref <> 0
    elements := jd.readJavaIntBE(aref + 2)
    if index => 0 AND index < elements
      val := jd.readJavaByte(aref + 4 + index)
      js.push(val)    'push value
      jd.incJvmPC(1)
    else
      je.throw(je#kIndexOutOfBoundsException)
  else
    je.throw(je#kNullPointerException)
}
'  index := js.pop 'get index
  call         #pop
  mov          t0,  rc      ' t0 = index
'  aref := js.pop  'get reference
  call         #pop

  rdlong       t2,  hp  ' get heap
  cmp          rc,  t2 wz,wc ' if aref >= heap
  if_ae sub    rc,  jem ' get aref no jem offset

  mov          t1,  rc      ' t1 = aref
' aref == 0 ?
  cmp          rc,  #0  wz
  if_z  jmp    #nullExcptnBALOAD
{
  if_z  call   #branch
  long  $1ff & (nullExcptnBALOAD-$)
}
'  if aref <> 0
'    elements := jd.readJavaIntBE(aref + 2)
  add          rc,  #2
  call         #loadWord
  mov          t2,  rc      ' t2 = elements
'    if index => 0 AND index < elements
  cmp          t0,  #0 wz,wc
  if_b  jmp    #oobExcptnBALOAD
{
  if_b  call   #branch
  long  $1ff & (oobExcptnBALOAD-$)
}
  cmp          t0,  t2 wz,wc
  if_ae jmp    #oobExcptnBALOAD
{
  if_ae call   #branch
  long  $1ff & (oobExcptnBALOAD-$)
}
'      val := jd.readJavaByte(aref + 4 + index)
  mov          rc, t1
  add          rc, #4
  add          rc, t0
  call         #loadByte
'      js.push(val)    'push value
'      jd.incJvmPC(1)
  jmp          #pushIncrPCdone
'    else
'      je.throw(je#kIndexOutOfBoundsException)
oobExcptnBALOAD
  mov          t0, x4000  
'  else
'    je.throw(je#kNullPointerException)
nullExcptnBALOAD
  jmp          #exception

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_BASTORE
'' doJem_BASTORE Meaning: Store into signed byte array.
{
  Description: An integer is popped off the stack, converted to a signed byte, and stored in the array at the index.
  The aref must be a reference to an array of signed bytes, and the index into the array must be an integer.
  If the integer value is too large to be a signed byte, it is truncated.
 
  jem format: bastore

  val := js.pop   'get value
  index := js.pop 'get index
  aref := js.pop  'get reference
  if aref <> 0
    elements := jd.readJavaIntBE(aref + 2)
    if index => 0 AND index < elements
      jd.writeJavaByte(aref + 4 + index,val)
      jd.incJvmPC(1)
    else
      je.throw(je#kIndexOutOfBoundsException)
  else
    je.throw(je#kNullPointerException)
}
'  val := js.pop   'get value
  call         #pop
  mov          t3,  rc      ' t3 = value
'  index := js.pop 'get index
  call         #pop
  mov          t0,  rc      ' t0 = index
'  aref := js.pop  'get reference
  call         #pop

  rdlong       t2,  hp  ' get heap
  cmp          rc,  t2 wz,wc ' if aref >= heap
  if_ae sub    rc,  jem ' get aref no jem offset

  mov          t1,  rc      ' t1 = aref
  cmp          rc,  #0  wz    ' rc = aref
  if_z  jmp    #nullExcptnBASTORE
{
  if_z  call   #branch
  long  $1ff & (nullExcptnBASTORE-$)
}
'  if aref <> 0
'    elements := jd.readJavaIntBE(aref + 2)
  add          rc,  #2        ' rc = aref + 2
  call         #loadWord
  mov          t2,  rc      ' t2 = elements
'    if index => 0 AND index < elements
  cmp          t0,  #0 wz,wc
  if_b  jmp    #oobExcptnBASTORE
{
  if_b  call   #branch
  long  $1ff & (oobExcptnBASTORE-$)
}
  cmp          t0,  t2 wz,wc
  if_ae jmp    #oobExcptnBASTORE
{
  if_ae call   #branch
  long  $1ff & (oobExcptnBASTORE-$)
}
'      jd.writeJavaByte(aref + 4 + index,val)
  mov          arg1,t1
  add          arg1,#4
  add          arg1,t0
  mov          rc,  t3
  call         #saveByte
'      jd.incJvmPC(1)
  jmp          #IncrPCdone
'    else
'      je.throw(je#kIndexOutOfBoundsException)
oobExcptnBASTORE  
  mov          t0, x4000
'  else
'    je.throw(je#kNullPointerException)
nullExcptnBASTORE
  jmp          #exception
  
long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_LDC
'' doJem_LDC Meaning: Push item from constant pool.
{
  jem format: ldc,byte1
  byte1 is index in String Indextable

  index := jd.readJavaByte(jd.getJvmPC+1)
  val := jd.getLdc(index)
  js.push(val) 
  jd.incJvmPC(2)
}
  call         #loadBytePcPlus1
  call         #loadConst   ' rc = index
  jmp          #pushIncrPC2done

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_LDC_W
'' Meaning: Push 2-byte item from constant pool.
{
  jem format: ldc_w,byte1,byte2
  byte1 is always 0. byte2 is index in String Indextable

  index := jd.readJavaByte(jd.getJvmPC+2)
  val := jd.getLdc(index)
  js.push(val) 
  jd.incJvmPC(3)
}
  rdlong       rc,  pc
  add          rc,  #2
  call         #loadByte
  call         #loadConst
  jmp          #pushIncrPC3done
  
long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_LDC2_W            ' not used ... table just says jump

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IMUL
'' doJem_IMUL Meaning: Integer multiply.
{
  jem format: imul

  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  w1 := w1 * w2
  jd.clearCarry
  if w1 < -32768 OR w1 > 32767
    jd.setCarry
  js.push(w1)
  jd.incJvmPC(1)
}
  call        #pop2signed
  call        #multiply
  mov         arg1,   rc
  call        #signResult
  jmp         #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IREM
'' doJem_IREM Meaning: Integer remainder.
{
  jem format: irem

  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  if w2 <> 0
    w1 := w1 // w2
    jd.clearCarry
    if w1 < -32768 OR w1 > 32767
      jd.setCarry
    js.push(w1)
    jd.incJvmPC(1)
}
  call        #pop2signed
  cmp         arg1, #0 wz
  if_z  jmp   #exception
  'if_z  jmp   #pushIncrPCdone ' just get out if divisor is zero

  call        #divide         ' mod result in arg2
  mov         arg1,   arg2
  'call        #signResult     ' result should be in arg1
  mov         rc, arg1
  jmp         #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_IDIV
'' doJem_IDIV Meaning: Integer divide.
{
  jem format: idiv

  w2 := js.pop
  w2 := ~~w2 'sign extend b15
  w1 := js.pop
  w1 := ~~w1 'sign extend b15
  if w2 <> 0
    w1 := w1 / w2
    jd.clearCarry
    if w1 < -32768 OR w1 > 32767
      jd.setCarry
    js.push(w1)
    jd.incJvmPC(1)
}
  call        #pop2signed
  cmp         arg1, #0 wz
  if_z  jmp   #exception
                          
  call        #divide         ' div result in arg1
  call        #signResult
  jmp         #pushIncrPCdone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_JSR
'' doJem_JSR Meaning: Jump subroutine.
{
  Description: Execution proceeds at the signed 16-bit offset from the address of this instruction.
  The offset is constructed from byte1 and byte2. The address of the instruction immediately following
  the current instruction is pushed onto the stack to provide a return address from the subroutine.
  The jsr instruction is used with the ret instruction in the implementation of the finally clauses of the
  Java programming language. Note that jsr pushes the address onto the operand stack and ret gets it out
  of a local variable. This asymmetry is intentional.

  jem format: jsr,byte1,byte2

  offset := jd.readJavaIntBE(jd.getJvmPC+1)
  js.push(jd.getJvmPC+3)
  jd.setJvmPC(jd.getJvmPC + offset)
}
  rdlong       rc,  pc
  mov          t0,  rc
  add          rc,  #3
  call         #push
  call         #loadWordPcPlus1
  add          t0,  rc
  wrlong       t0,  pc
  jmp          #jvmDone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_RET
'' doJem_RET Meaning: Return from subroutine.
{
  Description: Local variable in the current Java frame must contain a return address.
  The contents of the local variable are written into the program counter.
  The ret instruction is used with jsr or jsr_w instructions in the implementation of the finally clauses of the
  Java programming language. Note that jsr pushes the address onto the operand stack and ret gets it out of a
  local variable. This asymmetry is intentional. The ret instruction should not be confused with the return
  instruction. A return instruction returns control from a method to its invoker, without passing any value back
  to the invoker. The ret opcode can be used in conjunction with the wide instruction to access a local variable
  using a two-byte unsigned index.
 
  jem format: ret,byte1

  index := jd.readJavaByte(jd.getJvmPC+1)
  retaddr := jd.readJavaIntBE(jd.getJvmFP + (index<<1))
  jd.setJvmPC(retaddr)
}
  call         #loadBytePcPlus1
  shl          rc,  #1           ' rc = index
  rdlong       t0,  fp         ' t0 = fp
  add          t0,  rc
  call         #loadWord         ' load ret address
  wrlong       rc,  pc         ' save ret address
  jmp          #jvmDone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_TABLESWITCH
'' doJem_TABLESWITCH Meaning: Access jump table by index and jump.
{
  Description: Immediately after the tableswitch instruction, padding consisting of 0-3 zeros 
  is inserted so that the next byte begins at an address that is a multiple of four. A series of 
  offsets follows the padding. These offsets are signed 4-byte quantities and consist of a default 
  offset, a low offset, and a high offset, followed by additional <high-low+1> offsets. These 
  additional offsets are treated as a 0-based jump table.  

  The index the offsets point to must be an integer. If the index is less than the low offset or 
  greater than the high offset, the default offset is added to the address of the current 
  instruction. Otherwise, the low offset is subtracted from the index, and the element at the 
  position index - low offset in the jump table is extracted and added to the address of the 
  current instruction.

  jem format: tableswitch,byte1,byte2,byte3,byte4,byte5,byte6,<number of offsets>
  default offset = (byte1<<8)|(byte2). Low value = (byte3<<8)|(byte4). High value - low value = (byte5<<8)|(byte6).

  default := jd.readJavaIntBE(jd.getJvmPC+1)
  low := jd.readJavaIntBE(jd.getJvmPC+3)
  high := jd.readJavaIntBE(jd.getJvmPC+5) + low
  index := js.pop 'get index
  if index < low OR index > high
    jd.incJvmPC(default+1)
  else
    index -= low
    offset := jd.readJavaIntBE(jd.getJvmPC + 7 + (index<<1))
    jd.incJvmPC(offset+1)
}
  call         #loadWordPcPlus1
  mov          t0,  rc      ' t0 = default
  
  rdlong       rc,  pc
  add          rc,  #3
  call         #loadWord
  mov          t1,  rc      ' t1 = low

  rdlong       rc,  pc
  add          rc,  #5
  call         #loadWord
  add          rc,  t1      ' add low
  mov          t2,  rc      ' t2 = high

  call         #pop
  mov          t3,  rc      ' t3 = index
           
  cmp          t3,  t1  wz,wc
  if_b  jmp    #skipTABLESWITCH ' if index < low, exit
{
  if_b  call   #branch
  long  $1ff & (skipTABLESWITCH-$)
}
  cmp          t3,  t2  wz,wc
  if_a  jmp    #skipTABLESWITCH ' if index > high, exit
{
  if_a  call   #branch
  long  $1ff & (skipTABLESWITCH-$)
}
' index is in bounds; do work
  sub          t3,  t1      ' index -= low
  shl          t3,  #1      ' index <<= 1
  rdlong       rc,  pc      ' rc = pc

  add          rc,  #7      ' rc = pc + 7
  add          rc,  t3      ' rc = pc + 7 + index << 1
  call         #loadWord    ' offset = loadword(pc + 7 + index << 1)
  
  add          rc,  #1
  jmp          #addRcPCDone

skipTABLESWITCH  
' index is out of bounds
  add          t0,  #1
  mov          rc,  t0
  jmp          #addRcPCDone

long    0   ' end of method

'_____________________________________________________________________________
dat     org inst
'
doJem_LOOKUPSWITCH
'' doJem_LOOKUPSWITCH Meaning: Access jump table by key match and jump.
{
  Description: Immediately after the lookupswitch instruction, padding consisting of 0-3 
  zeros is inserted so that the next byte begins at an address that is a multiple of four. A series 
  of pairs of offsets follows the padding. These offsets are signed 4-byte quantities. The first 
  item in the pair is the default offset, and the second item in the pair gives the number of pairs 
  that follow. The additional pairs consist of a match and an offset.  

  The integer key on the stack is then compared against each of the matches. If the key is equal 
  to one of the matches, the offset is added to the address of the current instruction. If the key  
  does not match any of the matches, the default offset is added to the address of the current instruction.
 
  jem format: lookupswitch,byte1,byte2,byte3,byte4,<number of pairs: match,offset>
  default offset = (byte1<<8)|(byte2). Number of pairs = (byte3<<8)|(byte4).

  default := jd.readJavaIntBE(jd.getJvmPC+1)
  npairs := jd.readJavaIntBE(jd.getJvmPC+3)
  key := js.pop 'get key
  index := 5
  repeat npairs
    match := jd.readJavaIntBE(jd.getJvmPC + index)
    offset := jd.readJavaIntBE(jd.getJvmPC + index + 2)
    if key == match
      jd.incJvmPC(offset+1)
      return
    index += 4
  jd.incJvmPC(default+1)
}
  call         #loadWordPcPlus1
  mov          t0,  rc      ' t0 = default

  rdlong       rc,  pc
  add          rc,  #3
  call         #loadWord
  mov          t1,  rc      ' t1 = npairs

  call         #pop
  mov          t2,  rc      ' t2 = key
  mov          t3,  #5        ' t3 = index  

npairsLOOKUPSWITCH
  rdlong       rc,  pc      ' rc = pc
  add          rc,  t3      ' rc = pc + index
  mov          t5,  rc      ' t5 = pc + index
  add          t5,  #2        ' t5 = pc + index + 2
  call         #loadWord      ' match := jd.readJavaIntBE(jd.getJvmPC + index)
  mov          t4,  rc      ' t4 = match
              
  mov          rc,  t5
  call         #loadWord
  'mov          t5,  rc      ' t5 = offset

  cmp          t2,  t4 wz,wc
  if_ne jmp    #skipLOOKUPSWITCH' if key <> match, continue (next npairs lookup)
{
  if_ne call   #branch
  long  $1ff & (skipLOOKUPSWITCH-$)
}
  add          rc,  #1        ' offset + 1
  jmp          #addRcPCDone
  
skipLOOKUPSWITCH
  add          t3,  #4
  djnz         t1,  #npairsLOOKUPSWITCH
{
  sub          t1, #1
  cmp          t1, #0 wz
  if_nz call   #branch
  long  $1ff & (npairsLOOKUPSWITCH-$)
}
  mov          rc,  t0
  add          rc,  #1        ' default + 1
  jmp          #addRcPCDone

long 0  ' end of method

doJem_ENDOFTABLE      


dat
progbuf
program file "jem.bin"
program_end
byte 0 [JAVACODESIZE-(@program_end-@program)]
progbuf_end


