con

obj          
  def : "pjdef"
  pjd : "pjdata"
  vp  : "pjvmvp"
#ifdef FDX
  sio : "FullDuplexSingleton"       ' Simple Serial costs more bytes but fewer COGS
#else
  sio : "SingleSerial"
#endif

PUB start(num)
  vp.start(num)
  
PUB doNative(nm_function) | prm0,prm1,prm2,prm3,prm4,retval
{{
   Execute a native function. prmuments for native functions are either in VP registers
   or on the stack. If a native function returns a value it must be placed on top of the stack.
}}
  case nm_function
     0: prm1 := pjd.pop
        prm0 := pjd.pop
        case prm0
          def#nmPeriph0Bank..(def#nmPeriph0Bank+def#MAX_NUM_VPS*16-1):
            writeVPregister(prm0,prm1)
          other:
            pjd.writeJVMregister(prm0,prm1)
     1: prm0 := pjd.pop
        case prm0
          def#nmPeriph0Bank..(def#nmPeriph0Bank+def#MAX_NUM_VPS*16-1):
            retval := readVPregister(prm0)
          other:
            retval := pjd.readJVMregister(prm0)
        pjd.push(retval)
     2: prm1 := pjd.pop
        prm0 := pjd.pop
        nm_core_CPU_writeObject(prm0,prm1)
     3: prm0 := pjd.pop
        nm_core_CPU_delay(prm0)
     4: prm1 := pjd.pop
        prm0 := pjd.pop
        message(prm0,prm1)
     5: nm_page_
     6: prm2 := pjd.pop
        prm1 := pjd.pop
        prm0 := pjd.pop
        nm_core_CPU_count(prm0,prm1,prm2)
     7: prm2 := pjd.pop
        prm1 := pjd.pop
        prm0 := pjd.pop
        retval := nm_core_CPU_rcTime(prm0,prm1,prm2)
        pjd.push(retval)
     8: prm2 := pjd.pop
        prm1 := pjd.pop
        prm0 := pjd.pop
        retval := nm_core_CPU_pulseIn(prm0,prm1,prm2)
        pjd.push(retval)
     9: prm1 := pjd.pop
        prm0 := pjd.pop
        nm_core_CPU_pulseOut(prm0,prm1)
    10: prm0 := pjd.pop
        retval := nm_core_CPU_readPin(prm0)
        pjd.push(retval)
    11: prm1 := pjd.pop
        prm0 := pjd.pop
        nm_core_CPU_writePin(prm0,prm1)
    12: prm3 := pjd.pop
        prm2 := pjd.pop
        prm1 := pjd.pop
        prm0 := pjd.pop
        retval := nm_core_CPU_shiftIn(prm0,prm1,prm2,prm3)
        pjd.push(retval)
    13: prm4 := pjd.pop
        prm3 := pjd.pop
        prm2 := pjd.pop
        prm1 := pjd.pop
        prm0 := pjd.pop
        nm_core_CPU_shiftOut(prm0,prm1,prm2,prm3,prm4)
    14: retval := !pjd.isCarry & 1 
{
        'sio.str(string($d,"Carry"))
        sio.dec(retval)
        sio.out(" ")
'}
        pjd.push(retval)
    15: nm_page_
    16: prm0 := pjd.pop
        nm_core_CPU_uninstall(prm0)
    17: prm0 := pjd.pop
        nm_core_CPU_install(prm0)
    18: prm0 := pjd.pop
        nm_core_CPU_nap(prm0)
    19: prm0 := pjd.pop
        nm_core_CPU_setOutput(prm0)
    20: nm_page_
    21: prm0 := pjd.pop
        nm_core_CPU_setInput(prm0)
    22: nm_page_
    23: prm0 := pjd.pop
        retval := nm_core_CPU_readSRAM(prm0)
        pjd.push(retval)
    24: nm_page_
    25: prm1 := pjd.pop
        prm0 := pjd.pop
        nm_core_CPU_writeSRAM(prm0,prm1)
    26: nm_page_
    27: prm0 := pjd.pop
        retval := nm_core_EEPROM_eeRead(prm0)
        pjd.push(retval)
    28: nm_page_
    29: prm1 := pjd.pop
        prm0 := pjd.pop
        nm_core_EEPROM_eeWrite(prm0,prm1)
    30: nm_page_
    31: prm0 := pjd.pop
        nm_core_Uart_txInit(prm0)
    32: prm0 := pjd.pop
        nm_core_Uart_rxInit(prm0)
    33: prm0 := pjd.pop
        retval := nm_core_Uart_rxRead(prm0)
        pjd.push(retval)
    34: nm_core_Callback_returnTwo
    35: prm0 := pjd.pop
{
        sio.str(string($d,"init "))
        sio.dec(prm0)
        sio.out($d)
'}
        nm_core_Timer_init(prm0)
    36: prm0 := pjd.pop
{
        sio.str(string($d,"latch "))
        sio.dec(prm0)
        sio.out($d)
'}
        nm_core_Timer_latch(prm0)
    37: nm_page_
    38: prm0 := pjd.pop
        nm_core_PWM_install(prm0)
    39: nm_page_
    40: prm4 := pjd.pop
        prm3 := pjd.pop
        prm2 := pjd.pop
        prm1 := pjd.pop
        prm0 := pjd.pop
        nm_core_PWM_updateInternal(prm0,prm1,prm2,prm3,prm4)
    41: nm_page_
    42: prm0 := pjd.pop
        nm_core_DAC_install(prm0)
    43: nm_page_
    44: prm0 := pjd.pop
        nm_core_ADC_install(prm0)
    45: nm_page_
    46: retval := getByte
        pjd.push(retval)
    47: nm_page_

PUB message(s,len) | c, n
{{ send message to IDE message window }}
{{ this is the native CPU.message() and should not be used for debugging the jvm }}
  len--
  repeat n from 0 to len
    c := pjd.readJavaByte(s + 4 + n)
    sio.tx(c)
   
PUB getByte: value | i
{{ Native method getByte }}
  result := sio.rx ' sio.rxcheck ' for full duplex serial
  if result > -1
    sio.tx(result)

    
PRI nm_core_CPU_writeObject(register,value) | addr
{{ Used by stamp\core\Uart.java method start() to write 256byte buffer object reference into nmUartBufferH/L }}
{{ So nmUartBufferH/L holds address of byte array object, buffer really starts at +4 offset }}
  addr := pjd.getProgBase + value
  writeVPregister(register,  (addr >> 8) & $ff) 'store highbyte
  writeVPregister(register+1, addr & $ff)    'store lowbyte
  

PRI nm_core_CPU_delay(period) | t
  '/**
  ' * Delays the program execution for a period of time. The delay method does not
  ' * return until the delay period has expired. During a delay any installed Virtual
  ' * Peripherals will continue to run.
  ' * <p>
  ' *
  ' * @param period the length of time to delay for, measured in
  ' * 95.48 microsecond units.
  ' */
  't := cnt
  'repeat until (cnt - t) / (clkfreq * 95.48 / 1000000) > period
  
'{
  t := (vp.getTickPeriod*9548)/1000
  repeat period
    waitcnt(t+cnt)
'}
  
PRI nm_core_CPU_count(timeout,portPin,edge): value | pin,t
  '/**
  ' * Count the number of rising or falling edge transitions that occur during
  ' * a set period of time.
  ' * If the pin is an output then it will be changed to be an input and will remain as
  ' * an input when the counting is complete.
  ' * <p>
  ' * To ensure reliable detection the input signal must maintain a value for at least
  ' * 8.68us. This means that a square wave must have a period of at least 17.36us and
  ' * a frequency less than 57.6kHz.
  ' *
  ' * @param timeout the amount of time to count transitions over. Measured in
  ' *                8.68us units. The value of 32,767 allows a maximum measurement
  ' *                time of 284.4ms.
  ' * @param portPin the I/O pin to measure transitions on.
  ' * @param edge    the type of edge to count. Pass true to count rising edges,
  ' *                or false to count falling edges.
  ' * @return the number of rising edges or falling edges that occured on the pin
  ' *         during the timeout period.
  ' */
  {{ adapted from object BS2_functions PUB COUNT (Pin, Duration) : Value }}
  {{ only does rising-edge pulses now  }}
  pin := propPin(portPin)
  dira[pin]~                                          ' Set as input
  ctra := 0                                           ' Clear any value in ctrb
                                                           ' set up counter, pos edge trigger
  ctra := (%01010 << 26 ) | (%001 << 23) | (0 << 9) | (pin)  
  frqa := 1                                           ' 1 count/trigger
  phsa := 0                                           ' Clear phase - holds accumulated count
  t := cnt
  repeat until (cnt - t) / (clkfreq * 8.68 / 1000000) > timeout ' Allow to count for duration in 8.68us units 
  value := phsa                                       ' Return total count
  ctra := 0                                           ' clear counter mode


PRI nm_core_CPU_rcTime(timeout,portPin,pinState): value | pin, ClkStart,clkStop
  '/**
  ' * Measure the length of time it takes for a pin to match a desired value.
  ' * If the pin is an output then it will be changed to be an input and will
  ' * remain as an input when rcTime is complete. rcTime can be used to measure
  ' * the charge/discharge time of a RC (resistor-capacitor) circuit in order to
  ' * read an analogue value.
  ' *
  ' * @param timeout the maximum measurable time.
  ' * @param portPin the I/O pin to measure.
  ' * @param pinState the pin state to wait for.
  ' * @return the amount of time taken for the pin to change to the desired value,
  ' * measured in 8.68us units. A value of -1 indicates that the timeout expired
  ' * before the desired state was reached.
  ' */
  {{ adapted from object BS2_functions PUB RCTIME (Pin,State):Duration | ClkStart, ClkStop }}
  pin := propPin(portPin)
  if pinState
    pinState := 1
  else
    pinState := 0
  dira[pin]~
  ClkStart := cnt                                         ' Save counter for start time
  waitpne(pinState << pin, |< pin, 0)                     ' Wait for opposite state to end
  clkStop := cnt                                          ' Save stop time
  value := (clkStop - ClkStart)/(clkfreq * 8.68 /1000000) ' calculate in 8.68us resolution


PRI nm_core_CPU_pulseIn(timeout,portPin,pinState): value | pin
  '/**
  ' * Measure the length of a single pulse. Waits for the value of the selected
  ' * pin to match the value selected by the state parameter and then times how
  ' * long it takes for the pin to return to its original state.
  ' * If the pin is an output then it will be changed to be an input and will
  ' * remain as an input when complete.
  ' * <p>
  ' * A pulse of less than 8.68us in duration may be missed.
  ' *
  ' * @param timeout  the maximum amount of time to spend in the pulseIn method.
  ' *                 The timeout covers the complete time of the process both
  ' *                 the wait for the start of the pulse and the time of the pulse.
  ' * @param portPin      the I/O pin to measure the pulse on.
  ' * @param pinState    whether to measure a high pulse (true) or a low pulse (false).
  ' * @return the length of the pulse in 8.68us units. A value of 0 indicates
  ' *         that no start edge was detected. A value of -1 indicates that no
  ' *         stop edge was detected.
  ' */
  {{ adapted from object BS2_functions PUB PULSIN_Clk(Pin, State) : Duration }}
  {{ need to implement timeout }}
  pin := propPin(portPin)
  dira[pin]~
  ctra := 0
  if pinState
    pinState := 1
  else
    pinState := 0
  if pinState == 1
    ctra := (%11010 << 26 ) | (%001 << 23) | (0 << 9) | (pin) ' set up counter, A level count
  else
    ctra := (%10101 << 26 ) | (%001 << 23) | (0 << 9) | (pin) ' set up counter, !A level count
  frqa := 1
  waitpne(pinState << pin, |< Pin, 0)                         ' Wait for opposite state ready
  phsa:=0                                                  ' Clear count
  waitpeq(pinState << pin, |< Pin, 0)                         ' wait for pulse
  waitpne(pinState << pin, |< Pin, 0)                         ' Wait for pulse to end
  value := phsa * 1000000 /clkfreq / 8.68                  ' Return duration as 8.68us units
  ctra :=0                                                 ' stop counter


PRI nm_core_CPU_pulseOut(length,portPin) | ClkCycles,pin
  '/**
  ' * Generate a pulse of a specific duration. If the pin is an input then it will
  ' * be changed to be an output and remain as an output when complete. To
  ' * ensure that a positive going pulse or negative going pulse is generated it
  ' * is a good idea to write a value to the pin first to put it into the correct
  ' * state. pulseOut inverts the value of the selected pin, waits for the
  ' * specified length of time, and then returns the pin to its original value.
  ' * <p>
  ' * The time is measured in 8.68us units with a maximum value of 32767 giving a
  ' * maximum pulse time of 284.4ms. A time of 0 will not cause a pulse.
  ' * pulseOut can be used to generate the control pulses for a servo motor.
  ' *
  ' * @param length the length of the pulse to generate, measured in 8.68us units.
  ' * @param portPin    the I/O to generate the pulse on.
  ' */
  {{ adapted from object BS2_functions PUB PULSOUT(Pin,Duration)  | clkcycles }}
  pin := propPin(portPin)
  ClkCycles := (length * clkfreq / 1000000 * 8.68 - 1250) #> 400  ' 400 = Minimum waitcnt value to prevent lock-up
                       ' duration * clk cycles for 8.68us
                                                           ' - inst. time, min cntMin
  dira[pin]~~                                              ' Set to output                                         
  !outa[pin]                                               ' set to opposite state
  waitcnt(clkcycles + cnt)                                 ' wait until clk gets there 
  !outa[pin]                                               ' return to orig. state


PRI nm_core_CPU_readPin(portPin): YesNo | pin
  '/**
  ' * Reads the logic value on a pin. If the pin is an output then it will be
  ' * changed to be an input and will remain as an input when complete.
  ' *
  ' * @param portPin the I/O pin to read.
  ' * @return the state of the pin where true indicates high and false indicates low.
  ' */
  pin := propPin(portPin)
  dira[pin]~ 'input
  return ina[pin] <> 0
    

PRI nm_core_CPU_writePin(portPin,value) | pin
  '/**
  ' * Set a pin to a logic state. Makes the selected pin high or low as selected
  ' * by the state parameter. If the pin is an input then it will be changed to
  ' * be an output and remain as an output when complete.
  ' *
  ' * @param portPin the I/O pin to write.
  ' * @param value the state to set the pin to (true=high, false=low).
  ' */
  pin := propPin(portPin)
  dira[pin]~~   'output
  if value == 0 'false
    outa[pin]~  'low
  else          'true
    outa[pin]~~ 'high


CON
  'shiftin modes
  PRE_CLOCK_MSB  = 0  'Specify pre-clock sampling and MSB-first transmission. 
  POST_CLOCK_MSB = 1  'Specify post-clock sampling and MSB-first transmission.
  PRE_CLOCK_LSB  = 2  'Specify pre-clock sampling and LSB-first transmission.
  POST_CLOCK_LSB = 3  'Specify post-clock sampling and LSB-first transmission.
  OnClock        = 4


PRI nm_core_CPU_shiftIn(dataPortPin,clockPortPin,bitCount,mode): value | Dpin,Cpin,InBit
  '/**
  ' * Read data from a synchronous serial device.
  ' * The clock pin outputs a clock signal and the data is clocked in form the data pin.
  ' * If the data pin is an output then it will be changed to be an input and remain as
  ' * an input when complete. If the clock pin is an input then it will be changed to be
  ' * an output and remain as an output when complete.
  ' * <p> The mode parameter selects pre/post clock sampling. Note that some devices
  ' * require pre-clock sampling. When pre-clock sampling is used the data pin is
  ' * sampled to obtain the first bit prior to any change of the clock pin. Clearly
  ' * the device must have had a clock pulse to output the first bit and this is
  ' * normally supplied by the previous call to shiftIn or shiftOut. Most
  ' * synchronous serial devices require a write (shiftOut) prior to reading and so the
  ' * clock for the first bit will be supplied by the shiftOut call. If the device must be
  ' * read without first being written to then the first read (shiftIn) should request an
  ' * extra bit to provide the initial clock pulse.
  ' * <p>
  ' * Note that the bit count can be set to higher than 16 (up to 256) if desired. When
  ' * a number greater than 16 is used the last 16 bits will be returned.
  ' *
  ' * @param dataPortPin the I/O pin to read data on.
  ' * @param clockPortPin the I/O pin on which to provide the clock to the external device.
  ' * @param bitCount the number of bits to count in (from 1 to 16). bitCount must not be 0.
  ' * @param mode the shifting and clocking mode to employ. This determines whether
  ' * bits are shifted into the least-significant-bit (LSb) or most-significant-bit (MSb)
  ' * first. The clocking mode determines whether the data is sampled before or after
  ' * the first clock transition. See the description for the possible values.
  ' * @return the bits shifted in on the data pin. The result contains bitCount bits and is
  ' * justified according to the mode setting. If MSb first is selected then the result
  ' * will be the data read in on the port. If LSb first is selected then the data is
  ' * returned MSb justified and must be shifted right (16-bitCount) bits to
  ' * obtain the correct value.
  ' */
  {{ adapted from object BS2_functions PUB SHIFTIN (Dpin, Cpin, Mode, Bits) : Value | InBit }}
{{
   Shift data in, master clock, for mode use BS2#MSBPRE, #MSBPOST, #LSBPRE, #LSBPOST
   Clock rate is ~16Kbps.  Use at 80MHz only is recommended.
     X := BS2.SHIFTIN(5,6,BS2#MSBPOST,8)
}}
  Dpin := propPin(dataPortPin)
  Cpin := propPin(clockPortPin)
  dira[Dpin]~                                            ' Set data pin to input
  outa[Cpin]:=0                                          ' Set clock low 
  dira[Cpin]~~                                           ' Set clock pin to output 
                                                
  If Mode == PRE_CLOCK_MSB                               ' Mode - MSB, before clock
       Value:=0
       REPEAT Bitcount                                         ' for number of bits
          InBit:= ina[Dpin]                                ' get bit value
          Value := (Value << 1) | InBit                    ' Add to  value shifted by position
          !outa[Cpin]                                      ' cycle clock
          !outa[Cpin]
          waitcnt(1000 + cnt)                              ' time delay

  elseif Mode == POST_CLOCK_MSB                            ' Mode - MSB, after clock              
       Value:=0                                                          
       REPEAT Bitcount                                         ' for number of bits                    
          !outa[Cpin]                                      ' cycle clock                         
          !outa[Cpin]                                         
          InBit:= ina[Dpin]                                ' get bit value                          
          Value := (Value << 1) | InBit                    ' Add to  value shifted by position
          waitcnt(1000 + cnt)                              ' time delay                            

  elseif Mode == POST_CLOCK_LSB                            ' Mode - LSB, after clock                    
       Value:=0                                                                                         
       REPEAT Bitcount                                         ' for number of bits                         
          !outa[Cpin]                                      ' cycle clock                          
          !outa[Cpin]                                                                             
          InBit:= ina[Dpin]                                ' get bit value                        
          Value := (InBit << (bitcount-1)) + (Value >> 1)      ' Add to  value shifted by position    
          waitcnt(1000 + cnt)                              ' time delay                           
       value <<= 8

  elseif Mode == PRE_CLOCK_LSB                             ' Mode - LSB, before clock             
       Value:=0                                                                                   
       REPEAT Bitcount                                         ' for number of bits                   
          InBit:= ina[Dpin]                                ' get bit value                        
          Value := (Value >> 1) + (InBit << (bitcount-1))      ' Add to  value shifted by position    
          !outa[Cpin]                                      ' cycle clock                          
          !outa[Cpin]                                                                             
          waitcnt(1000 + cnt)                              ' time delay
       value <<= 8

  elseif Mode == OnClock  {{ is this required ?? }}                                          
       Value:=0
       REPEAT Bitcount                                         ' for number of bits
                                        
          !outa[Cpin]                                      ' cycle clock
          waitcnt(500 + cnt)                               ' get bit value
          InBit:= ina[Dpin]                               ' time delay
          Value := (Value << 1) | InBit                    ' Add to  value shifted by position
          !outa[Cpin]
          waitcnt(500 + cnt)                           


CON
  'shiftout modes
  SHIFT_MSB = 0  'Specify MSB-first transmission.
  SHIFT_LSB = 2  'Specify LSB-first transmission. 


PRI nm_core_CPU_shiftOut(dataPortPin,clockPortPin,bitCount,mode,data) | Dpin,Cpin
  '/**
  ' * Write data to a synchronous serial device.
  ' * The clock pin outputs a clock signal and the data is clocked out the data pin. If
  ' * the data pin is an input then it will be changed to be an output and remain as an
  ' * output when complete. Likewise if the clock pin is an input then it will be
  ' * changed to be an output and remain as an output when complete.
  ' * <p>
  ' * Both the clock and data pins should be initialized before calling shiftOut. shiftOut
  ' * works by inverting the pins so you can generate either idle high or idle low signals.
  ' * <p>
  ' * If LSb first is selected then the data can be passed directly. If MSb first is
  ' * selected then if less than 16 bits are to be shift out, data should be shifted left
  ' * to MSb justify it.
  ' * @param dataPortPin the I/O pin to write data on.
  ' * @param clockPortPin the I/O pin on which to provide the clock to the external device.
  ' * @param bitCount the number of bits to count out (from 1 to 16). bitCount must not be 0.
  ' * @param mode the shifting mode to employ. This determines whether
  ' * bits are shifted into the least-significant-bit (LSb) or most-significant-bit (MSb)
  ' * first. Valid values are CPU.SHIFT_MSB and CPU.SHIFT_LSB.
  ' */
  {{ adapted from object BS2_functions PUB SHIFTOUT (Dpin, Cpin, Value, Mode, Bits)| bitNum  }}
{{
   Shift data out, master clock, for mode use ObjName#LSBFIRST, #MSBFIRST
   Clock rate is ~16Kbps.  Use at 80MHz only is recommended.
     BS2.SHIFTOUT(5,6,"B",BS2#LSBFIRST,8)
}}
  Dpin := propPin(dataPortPin)
  Cpin := propPin(clockPortPin)
  outa[Dpin]:=0                                          ' Data pin = 0
  dira[Dpin]~~                                           ' Set data as output
  outa[Cpin]:=0
  dira[Cpin]~~

  If Mode == SHIFT_LSB                                    ' Send LSB first    
       REPEAT Bitcount
          outa[Dpin] := data & 1                         ' Set output
          data := data >> 1                              ' Shift value right
          !outa[Cpin]                                    ' cycle clock
          !outa[Cpin]
          waitcnt(1000 + cnt)                            ' delay

  elseIf Mode == SHIFT_MSB                               ' Send MSB first
       data >>= 8               ' MSB data is expected on the high byte lane
       REPEAT Bitcount                                                                
          outa[Dpin] := (data >> (bitcount-1)) & 1       ' Set output
          data := data << 1                              ' Shift value right    
          !outa[Cpin]                                    ' cycle clock
          !outa[Cpin]                                                             
          waitcnt(1000 + cnt)                            ' delay
    outa[Dpin]~                                            ' Set data to low
     

  
PRI nm_core_CPU_uninstall(bank)
  '/**
  ' * This function is called by CPU.removeVP. 
  ' * Remove a virtual peripheral from its slot. The VP will stop executing
  ' * immediately and its slot will be available to install a different VP.
  ' *
  ' * @param bank the rambank allocated to the virtual peripheral that must stop.
  ' */
  writeVPregister(bank + def#nmPeriphISRVec, 0)


PRI nm_core_CPU_install(routine)
  'Appears not to be used

  
PRI nm_core_CPU_nap(period) | t,delayms
  'If the Prop cannot support nap, then just do a delay
  '/**
  ' * Put the Prop into sleep mode for a period of time. The accuracy
  ' * of the sleep timer is very poor. See the manual for more information.
  ' *
  ' * @param period specifies the period for which the Prop should sleep. The
  ' * following values are valid:
  ' *
  ' * 0 - 16ms
  ' * 1 - 32ms
  ' * 2 - 64ms
  ' * 3 - 128ms
  ' * 4 - 256ms
  ' * 5 - 512ms
  ' * 6 - 1024ms
  ' * 7 - 2048ms
  ' */
  delayms := 1 << period
  repeat delayms
    waitcnt((clkfreq*16)/1000)
  ' peters original  
  'delayms := 16 << period 'number of milliseconds to delay
  't := cnt
  'repeat until (cnt - t) / (clkfreq/1000) => delayms


PRI nm_core_CPU_setOutput(portPin) | port
  '/**
  ' * Make a pin an output.
  ' * The specified pin will be converted to an output. More than one pin can
  ' * be specified using the | operator, as long as all pins are on the same
  ' * port.
  ' *
  ' * @param portPin the pin(s) to make into an output.
  ' */
  port := portPin >> 8
  portPin &= $FF
  case port
    0: dira[7..0] |= portPin
    1: dira[15..8] |= portPin
    2: dira[23..16] |= portPin
    3: dira[31..24] |= portPin
    

PRI nm_core_CPU_setInput(portPin) | port
  '/**
  ' * Make a pin an input.
  ' * The specified pin will be converted to an input. More than one pin can
  ' * be specified using the | operator, as long as all pins are on the same
  ' * port.
  ' *
  ' * @param portPin the pin(s) to make into an input.
  ' */
  port := portPin >> 8
  portPin := (portPin ^ $FF) & $FF
  case port
    0: dira[7..0] &= portPin
    1: dira[15..8] &= portPin
    2: dira[23..16] &= portPin
    3: dira[31..24] &= portPin


PRI nm_core_CPU_readSRAM(address): value
  '/**
  ' * Reads a byte from SRAM at the specified address.
  ' * The address will be mapped into the device memory range.
  ' * This is an internal function and should not be used.
  ' *
  ' * @param address the address to read the byte from.
  ' * @return the byte read from the SRAM.
  ' */
  address //= pjd.getMemSize 'to compensate for size 0x8000 in true javelin
  return pjd.readJavaByte(address)
  

PRI nm_core_CPU_writeSRAM(address,value)
  '/**
  ' * Writes a byte into the SRAM at the specified address.
  ' * The address will be mapped into the device memory range.
  ' * This is an internal function and should not be used.
  ' *
  ' * @param address the address to write the byte to.
  ' * @param value value to write.
  ' */
  address //= pjd.getMemSize 'to compensate for size 0x8000 in true javelin
  pjd.writeJavaByte(address,value)
  

PRI nm_core_EEPROM_eeRead(address): value
  '/**
  ' * Reads a byte from the EEPROM at the specified address.
  ' *
  ' * @param address the address to read the byte from.
  ' * @return the byte read from the EEPROM.
  ' */
  address -= ($8000 - pjd.getMemSize) 'to compensate for constant 0x7FFF used in EEPROM.java
  return pjd.eeReadByte(address)
        

PRI nm_core_EEPROM_eeWrite(address,value) | ack 
  '/**
  ' * Writes a byte into the EEPROM at the specified address.
  ' *
  ' * @param address the address to write the byte to.
  ' * @param value value to write.
  ' */
  address -= ($8000 - pjd.getMemSize) 'to compensate for constant 0x7FFF used in EEPROM.java
  pjd.eeWriteByte(address,value)


PRI nm_core_Callback_returnTwo
  'This appears not to be used

  
PRI nm_page_
  'Since the Prop has no pages, simply ignore ???

PUB propPin(portPin): pin | port
{{ convert javelin portPin format to propeller pin format }}
' THINK WE CAN WASTE A LITTLE MORE TIME AND A FEW MORE BYTES? UGGH!
  port := portPin >> 8
  pin := >| (portPin & $FF)
  pin--
  case port
    1: pin += 8
    2: pin += 16
    3: pin += 24
  return pin


CON
{{
Connecting this stuff here since basic jvmVpCore device access works here.
Moving this to another module like jvmVirtualPeripheral breaks basic function.
I've seen this kind of "layer" breakage before; please do not move code.
}}

PRI invalidAddr(address)
  if address < def#nmPeriph0Bank or address > def#nmPeriph0Bank+def#MAX_NUM_VPS*16
    return -1
  return 0

PRI getDev(address)
  result := address & def#nmBlockBank           ' kill msb
  result := result >> 5                         ' get 1 of 3 vp devices - 0, 1, 2

PRI getAddr(address)
  result := address & (def#nmPeriph1Bank | $f)        ' use nmPeriph0Bank or nmPeriph1Bank
    
PUB writeVPregister(address,value) | devd, addr
{{ write value to vpRambank register }}
'  if (address > pjd.getHP)
'    address -= pjd.getProgOffset
  devd := getDev(address)
  addr := getAddr(address)
{  
  sio.str(string("WRV "))
  sio.hex(address,4)
  sio.out(" ")
  sio.hex(devd,1)
  sio.out(" ")
  sio.hex(addr,2)
  sio.out(" ")
  sio.hex(value,4)
  sio.out($d)
'}   
  vp.writeReg(devd, addr, value)
  
  
PUB readVPregister(address):value | devd, addr 
{{ read value from vpRambank register }}
'  if (address > pjd.getHP)
'    address -= pjd.getProgOffset
  devd := getDev(address)
  addr := getAddr(address)
{
  sio.str(string("RDV "))
  sio.hex(address,4)
  sio.out(" ")
  sio.hex(devd,1)
  sio.out(" ")
  sio.hex(addr,2)
'}  
  result := vp.readReg(devd, addr)
{
  sio.out(" ")
  sio.hex(result,4)
  sio.out($d)
'}

PUB nm_core_Timer_init(bank)
  '/**
  ' * Initialize the 32bit counter. The 32bit nmTimer register should increment every 8.68 usec.
  ' * Called by Timer.start()
  ' *
  ' * @param bank The allocated area for the Timer registers.
  ' */
  vp.startVP(getDev(bank), getAddr(bank), def#VP_TIMER)  

PUB nm_core_Timer_latch(bank) | latchedCount, b1,b2,b3,b4
  '/**
  ' * Latch the 32bit counter into the latch registers.
  ' * Called by Timer.tickLo()
  ' *
  ' * @param bank The allocated area for the Timer registers.
  ' */

  latchedCount := vp.ReadTimer(getDev(bank))

  writeVPregister(bank + def#nmLatchTimer1, (latchedCount >>  0) & $ff)
  writeVPregister(bank + def#nmLatchTimer2, (latchedCount >>  8) & $ff)
  writeVPregister(bank + def#nmLatchTimer3, (latchedCount >> 16) & $ff)
  writeVPregister(bank + def#nmLatchTimer4, (latchedCount >> 24) & $ff)

{
  b1 := bank + def#nmTimer1
  b2 := bank + def#nmTimer2
  b3 := bank + def#nmTimer3
  b4 := bank + def#nmTimer4

  b1 := readVPregister(b1)
  b2 := readVPregister(b2)
  b3 := readVPregister(b3)
  b4 := readVPregister(b4)

  writeVPregister(bank + def#nmLatchTimer1, b1)
  writeVPregister(bank + def#nmLatchTimer2, b2)
  writeVPregister(bank + def#nmLatchTimer3, b3)
  writeVPregister(bank + def#nmLatchTimer4, b4)
'}

{
  writeVPregister(bank + def#nmLatchTimer1, readVPregister(bank + def#nmTimer1))
  writeVPregister(bank + def#nmLatchTimer2, readVPregister(bank + def#nmTimer2))
  writeVPregister(bank + def#nmLatchTimer3, readVPregister(bank + def#nmTimer3))
  writeVPregister(bank + def#nmLatchTimer4, readVPregister(bank + def#nmTimer4))
'}

PUB nm_core_ADC_install(bank) | port, pin, inmask,outmask
  '/**
  ' * Initialize an ADC as background task. Its parameters are in vpRambank.
  ' * Called by ADC.start()
  ' *
  ' * @param bank The allocated area for the ADC registers.
  ' * ADC pins are decimal number stored in nm*Pin & nm*Port registers. 
  ' */
  pin  := readVPregister(bank + def#nmAdcInPin) & $ff ' our registers are long
  port := readVPregister(bank + def#nmAdcInPort) & $ff
  inmask := pin << (port*8)

  pin  := readVPregister(bank + def#nmAdcOutPin) & $ff ' our registers are long
  port := readVPregister(bank + def#nmAdcOutPort) & $ff
  outmask := pin << (port*8)

  vp.startADC(getDev(bank), getAddr(bank), inmask, outmask)

  
PUB nm_core_DAC_install(bank) | port, pin, outmask
  '/**
  ' * Initialize a DAC as background task. Its parameters are in vpRambank.
  ' * Called by DAC.start()
  ' *
  ' * @param bank The allocated area for the DAC registers.
  ' */
  pin  := readVPregister(bank + def#nmDacPin) & $ff ' our registers are long
  port := readVPregister(bank + def#nmDacPort) & $ff
  outmask := pin << (port*8)

  vp.startDAC(getDev(bank), getAddr(bank), outmask, 0)

    
PUB nm_core_PWM_install(bank) | port, pin, outmask
  '/**
  ' * Initialize a PWM as background task. Its parameters are in vpRambank.
  ' * Called by PWM.start()
  ' *
  ' * @param bank The allocated area for the PWM registers.
  ' */
  pin  := readVPregister(bank + def#nmPWMPin) & $ff ' our registers are long
  port := readVPregister(bank + def#nmPWMPort) & $ff
  outmask := pin << (port*8)
  vp.startPWM(getDev(bank), getAddr(bank), outmask, 2, 2)  'initial values


PUB nm_core_PWM_updateInternal(bank,highTime,lowTime,highZero,lowZero)
  '/**
  ' * Update the PWM duty cycle. Its parameters are in vpRambank. 
  ' * Called by PWM.update()
  ' *
  ' * @param bank The allocated area for the PWM registers.
  ' * @param highTime the number of 8.68us the waveform should be high. (1-255)
  ' * @param lowTime the number of 8.68us the waveform should be low. (1-255)
  ' * @param highZero Boolean value (always true) that tells wether highTime != 0.
  ' * @param lowZero Boolean value (always true) that tells wether lowTime != 0.
  ' */
  writeVPregister(bank + def#nmPWMlowTime, lowTime)
  writeVPregister(bank + def#nmPWMhighTime, highTime)
  writeVPregister(bank + def#nmPWMlowZero, lowZero)
  writeVPregister(bank + def#nmPWMhighZero, highZero)
       

PUB nm_core_Uart_rxInit(bank) | bufptr,pin,port,invert,stopBits,baud,pinbits,hsbits
  '/**
  ' * Initialize a Uart receiver as background task. Its parameters are in vpRambank.
  ' * Called by Uart.start()
  ' *
  ' * @param bank The allocated area for the Uart registers.
  ' */
  pin := readVPregister(bank + def#nmUartPin) & $ff ' CPU.pin9 would be 2 bytes ? port is high byte of pin 
  port := readVPregister(bank + def#nmUartPort) & $ff
  pinbits := pin << (port*8)

  pin := readVPregister(bank + def#nmUartHSPin) & $ff ' CPU.pin9 would be 2 bytes ? 'if nmUartHSPin == 0, then pin := 32 ????
  port := readVPregister(bank + def#nmUartHSPort) & $ff 
  hsbits := pin << (port*8)

  pin += port*8
  if pin > 0 ' if using handshake (flow control) start in a good state
    dira[pin-1]~~
      if invert
        outa[pin-1]~
      else
        outa[pin-1]~~
          
  baud   := readVPregister(bank + def#nmUartBaud) & $ff
  invert := readVPregister(bank + def#nmUartInvert) & $01

  stopBits := >| readVPregister(bank + def#nmUartStopBits) 'nmUartStopBits is 1,3,7,15...255 so stopBits is 0 to 7
  stopBits += 10  'make it 1 to 8 stopbits + startbit + 8 databits
  ' dataBits and stopBits are ignored in asm driver for now
  
  bufptr := ((readVPregister(bank + def#nmUartBufferH) & $ff) << 8) + (readVPregister(bank + def#nmUartBufferL) & $ff) 'get buffer object reference
  bufptr += 4 ' bastore puts buffer at ref+4
  if (bufptr > pjd.getHP)
    bufptr -= pjd.getProgOffset    ' subtract program offset after HP setup

  vp.startURX(getDev(bank), getAddr(bank), pinbits, hsbits, baud, stopBits, invert, bufptr) ' initial values


PUB nm_core_Uart_rxRead(bank) | pin,head,tail,len,invert
  '/**
  ' * Inform Uart receiver a byte has been grabbed from the buffer, so the receiver can do the handshaking.
  ' * Called by Uart.readByte()
  ' *
  ' * @param bank The allocated area for the Uart registers.
  ' */

' handshake, backpressure, flow control, whatever you want to call it must be done in ASM driver for reliable results
' also make sure tail pointer does not overflow the receive buffer in ASM driver.
  
      
PUB nm_core_Uart_txInit(bank) | bufptr,pin,port,invert,stopBits,baud,pinbits,hsbits
  '/**
  ' * Initialize a Uart transmitter as background task. Its parameters are in vpRambank.
  ' * Called by Uart.start()
  ' *
  ' * @param bank The allocated area for the Uart registers.
  ' */
  pin := readVPregister(bank + def#nmUartPin) & $ff ' CPU.pin9 would be 2 bytes ? port is high byte of pin
  port := readVPregister(bank + def#nmUartPort) & $ff
  pinbits := pin << (port*8)

  pin := readVPregister(bank + def#nmUartHSPin) & $ff ' CPU.pin9 would be 2 bytes ? port is high byte of pin
  port := readVPregister(bank + def#nmUartHSPort) & $ff
  hsbits := pin << (port*8)

  baud   := readVPregister(bank + def#nmUartBaud) & $ff
  invert := readVPregister(bank + def#nmUartInvert) & $01

  stopBits := >| readVPregister(bank + def#nmUartStopBits) 'nmUartStopBits is 1,3,7,15...255 so stopBits is 0 to 7
  stopBits += 10  'make it 1 to 8 stopbits + startbit + 8 databits
  ' dataBits and stopBits ignored for now
  
  bufptr := ((readVPregister(bank + def#nmUartBufferH) & $ff) << 8) + (readVPregister(bank + def#nmUartBufferL) & $ff) 'get buffer object reference
  bufptr += 4 ' bastore puts buffer at ref+4
  if (bufptr > pjd.getHP)
    bufptr -= pjd.getProgOffset    ' subtract program offset after HP setup
  
  vp.startUTX(getDev(bank), getAddr(bank), pinbits, hsbits, baud, stopBits, invert, bufptr) ' initial values

                
